close all
instrreset
clear all
format long

% code for doing dielectric matching on measurements involving the Agilent 
% 5071C-ENA network analyzer

% The user creates a list of all the applicable file extensions of the
% measurements to be matched and selects which one to match by setting the
% value of "pressures" in line 17.  Be careful to use unique file name
% extensions, or previous data can be over-written.

G=2;
for R=1:19  % iterate through all the resonances

pressures=14;
    Rstr=num2str(R);
   % list of applicable file extensions
    if pressures==1
        filenm=strcat(Rstr, '_nh3_30mbar_pure');
    elseif pressures==2
        filenm=strcat(Rstr, '_nh3_4bars_quarterpercent');
    elseif pressures==3
        filenm=strcat(Rstr, '_nh3_8bars_quarterpercent');
    elseif pressures==4
        filenm=strcat(Rstr, '_nh3_12bars_quarterpercent');
    elseif pressures==5
        filenm=strcat(Rstr, '_nh3_8bars_16thpercent');
    elseif pressures==6
        filenm=strcat(Rstr, '_nh3_12bars_16thpercent');   
    elseif pressures==7
        filenm=strcat(Rstr, '_nh3_120mbar_pure');
    elseif pressures==8
        filenm=strcat(Rstr, '_nh3_12bars_1percent');
    elseif pressures==9
        filenm=strcat(Rstr, '_nh3_8bars_1percent');
    elseif pressures==10
        filenm=strcat(Rstr, '_nh3_6bars_1percent');
    elseif pressures==11
        filenm=strcat(Rstr, '_nh3_4bars_1percent');
    elseif pressures==12
        filenm=strcat(Rstr, '_nh3_2bars_1percent');
    elseif pressures==13
        filenm=strcat(Rstr, '_nh3_1bar_1percent');   
    elseif pressures==14
        filenm=strcat(Rstr, '_nh3_halfbar_1percent');           
    end  
% display original test gas measurements
    load (filenm)
    figure(R)
    subplot(2,2,1)
    plot(faxiswide,S11wide,'r')
    hold on
    subplot(2,2,2)
    plot(faxiswide,S12wide,'r')
    hold on
    subplot(2,2,3)
    plot(faxiswide,S21wide,'r')
    hold on
    subplot(2,2,4)
    plot(faxiswide,S22wide,'r')
    hold on
    figure(100*R)
    subplot(2,2,1)
    plot(faxis,S11,'r')
    hold on
    subplot(2,2,2)
    plot(faxis,S12,'r')
    hold on
    subplot(2,2,3)
    plot(faxis,S21,'r')
    hold on
    subplot(2,2,4)
    plot(faxis,S22,'r')
    hold on
    
    % process original test gas measurement to find center frequency
    [BW3dBa BW3dBe PeakFa PeakFe Qa Qe Levela Levele]=NAprocess(S21,numswp,faxis);  
    numpoints=1601;
    SweepTime=40;
cntr=0;
while cntr<1
if R <= 19
    NA = gpib('ni',0,17);
    NA.InputBufferSize=250000;
    fclose(NA)
    fopen(NA)
    fprintf(NA, ':OUTP ON')
    fprintf(NA, ':SENS1:CORR:CLE')              % clear calibration correction coefficient
    fprintf(NA, ':SENS1:SWE:DEL 0.01')          % sweep delay set to 10ms
    fprintf(NA, ':SENS1:SWE:GEN STEP')          % sweep set to stepped mode
    fprintf(NA, ':SOUR1:POW 0')                 % set source power to 0 dBm
    fprintf(NA, ':CALC1:FORM MLOG')             % log magnitude format
    if R==1
        beep
        pause(0.25)
        beep
        input('connect large resonator to network analyzer')
    end    
    
fprintf(NA, ':CALC1:PAR1:DEF S21')              % measure S(2,1)
fprintf(NA, ':SENS1:FREQ:CENT %f;', faxis(801))          % set center frequency
fprintf(NA, ':SENS1:FREQ:SPAN %f;', (faxis(1601)-faxis(1))*10)    % set frequency span
fprintf(NA, ':SENS1:BWID %f;', IFBW)            % Set IF bandwidth
fprintf(NA, ':SENS1:SWE:POIN %i;', numpoints)   % set # of points
fprintf(NA, ':SENS1:SWE:TIME:AUTO ON')          % turn on auto sweep time
fprintf(NA, ':SENS1:SWE:TIME?')                 % query sweep time
Swetime = fscanf(NA, '%f');
pause(0.5+Swetime)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
if G==2
input('zoom?')
end
fprintf(NA, ':SENS1:FREQ:SPAN %f;', (faxis(1601)-faxis(1)))    % set frequency span
pause(0.5+Swetime)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:MARK1:X %f', PeakFa)
    fprintf(NA, ':CALC1:DATA:FDAT?')
    S21Str = fscanf(NA);
    S210=strread(S21Str,'%f','delimiter',',');
    for i=1:2*numpoints
        if mod((i+1),2)==0
            S21t((i+1)/2,1)=S210(i);
        end
    end
    [BW3dBa BW3dBe PeakFa2 PeakFe Qa Qe Levela Levele]=NAprocess(S21t,1,faxis);
Gg=0;
    if PeakFa2>PeakFa
        state0=1;
    elseif PeakFa2<PeakFa
        state0=2;
    else
        state0=0;
    end
    i=1;
    
while i<4

if abs(PeakFa2-PeakFa)<(faxis(1601)-faxis(1))/400
    diff=12000;
    x=[1:1:diff];
    tone=[sin(x/10)/3 sin(x/10)/3]; % create tone to signal target frequency has been reached
    sound(tone,diff*3)              % play tone
    pause(1)
    i=i+1;
    state0=3;
else
    if Gg==0
    if PeakFa2>PeakFa
        beep
        pause(0.25)
        disp('add gas')
    elseif PeakFa2<PeakFa
        beep
        pause(0.25)
        beep
        pause(0.25)
        disp('remove gas')
    end
    end
    t=0.2;
    if PeakFa2~=PeakFa
        diff=4000*abs(log10(abs((PeakFa2-PeakFa)/(faxis(1601)-faxis(1)))));
    else
        diff=12000;
    end
    x=[1:1:diff];

    sound(sin(x/10)/3,diff/t)  % play tone based on distance to target frequency
    pause(0.5+Swetime)
    G=1;

end  

if i<4
    
    fprintf(NA, ':CALC1:DATA:FDAT?')
    S21Str = fscanf(NA);
    S210=strread(S21Str,'%f','delimiter',',');
    for m=1:2*numpoints
        if mod((m+1),2)==0
            S21t((m+1)/2,1)=S210(m);
        end
    end
    [BW3dBa BW3dBe PeakFa2 PeakFe Qa Qe Levela Levele]=NAprocess(S21t,1,faxis);
    if PeakFa2>PeakFa
        state1=1;
    elseif PeakFa2<PeakFa
        state1=2;
    else
        state1=0;
    end
    if state0==state1
        Gg=1;
    else
        Gg=0;
        state0=state1;
    end
end    
end    


if G>0
    T1=input('Starting Temperature in deg. C : ');
    P1=input('Starting gauge Pressure in bars (-1 for vacuum) : ');  
else
    T1=T2temp;
    P1=P2temp;
end
fprintf(NA, ':SENS1:FREQ:DATA?')                % query frequency data
faxisStr = fscanf(NA);
faxis=strread(faxisStr,'%f','delimiter',',');
for j=1:numswp                                  % measure S(2,1)
    fprintf(NA, ':CALC1:DATA:FDAT?')
    S21Str = fscanf(NA);
    S210=strread(S21Str,'%f','delimiter',',');
    for i=1:2*numpoints
        if mod((i+1),2)==0
            S21((i+1)/2,j)=S210(i);
        end
    end
    pause(Swetime)
end

fprintf(NA, ':CALC1:PAR1:DEF S12')              % measure S(1,2)
pause(Swetime+0.5)
for j=1:numswp                                  
    fprintf(NA, ':CALC1:DATA:FDAT?')
    S12Str = fscanf(NA);
    S120=strread(S12Str,'%f','delimiter',',');
    for i=1:2*numpoints
        if mod((i+1),2)==0
            S12((i+1)/2,j)=S120(i);
        end
    end
    pause(Swetime)
end
fprintf(NA, ':CALC1:PAR1:DEF S22')              % measure S(2,2)
pause(Swetime+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:DATA:FDAT?')
S22Str = fscanf(NA);
S220=strread(S22Str,'%f','delimiter',',');
for i=1:2*numpoints
    if mod((i+1),2)==0
        S22((i+1)/2)=S220(i);
    end
end
pause(Swetime)
fprintf(NA, ':CALC1:PAR1:DEF S11')              % measure S(1,1)
pause(Swetime+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:DATA:FDAT?')
S11Str = fscanf(NA);
S110=strread(S11Str,'%f','delimiter',',');
for i=1:2*numpoints
    if mod((i+1),2)==0
        S11((i+1)/2)=S110(i);
    end
end
fprintf(NA, ':SENS1:FREQ:SPAN %f;', faxiswide(numpoints)-faxiswide(1))    % set frequency span
fprintf(NA, ':SENS1:FREQ:CENT %f;', faxiswide((numpoints-1)/2+1)) 
fprintf(NA, ':CALC1:PAR1:DEF S21')              % measure S(2,1)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
pause(Swetime+1)    
fprintf(NA, ':CALC1:DATA:FDAT?')
S21wideStr = fscanf(NA);
S21wide0=strread(S21wideStr,'%f','delimiter',',');


fprintf(NA, ':CALC1:PAR1:DEF S12')              % measure S(1,2)
pause(Swetime+0.5)
                                  
    fprintf(NA, ':CALC1:DATA:FDAT?')
    S12wideStr = fscanf(NA);
    S12wide0=strread(S12wideStr,'%f','delimiter',',');
    
fprintf(NA, ':CALC1:PAR1:DEF S22')              % measure S(2,2)
pause(Swetime+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:DATA:FDAT?')
S22wideStr = fscanf(NA);
S22wide0=strread(S22wideStr,'%f','delimiter',',');

pause(Swetime)
fprintf(NA, ':CALC1:PAR1:DEF S11')              % measure S(1,1)
pause(Swetime+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:DATA:FDAT?')
S11wideStr = fscanf(NA);
S11wide0=strread(S11wideStr,'%f','delimiter',',');
for i=1:2*numpoints
    if mod((i+1),2)==0
        S21wide((i+1)/2)=S21wide0(i);
        S12wide((i+1)/2)=S12wide0(i);
        S22wide((i+1)/2)=S22wide0(i);
        S11wide((i+1)/2)=S11wide0(i);
    end
end

% perform check to make sure resonance hasn't drifted out of target range
[BW3dBa BW3dBe PeakFa2 PeakFe Qa Qe Levela Levele]=NAprocess(S21,numswp,faxis);
if (PeakFa2-PeakFa)>(faxis(1601)-faxis(1))/300
    disp('Match too high. Add gas, repeat measurement.')
    cntr=0;
    G=1;
elseif (PeakFa-PeakFa2)>(faxis(1601)-faxis(1))/300
    disp('Match too low. Remove gas, repeat measurement.')
    cntr=0;
    G=1;
else
    cntr=1;
figure(R)
subplot(2,2,1)
plot(faxiswide,S11wide)
title('S(1,1)')
subplot(2,2,2)
plot(faxiswide,S12wide)
title('S(1,2)')
subplot(2,2,3)
plot(faxiswide,S21wide)
title('S(2,1)')
subplot(2,2,4)
plot(faxiswide,S22wide)
title('S(2,2)')
figure(100*R)
subplot(2,2,1)
plot(faxis,S11)
title('S(1,1)')
subplot(2,2,2)
plot(faxis,S12)
title('S(1,2)')
subplot(2,2,3)
plot(faxis,S21)
title('S(2,1)')
subplot(2,2,4)
plot(faxis,S22)
title('S(2,2)')

end
fclose(NA)



else
    disp('invalid input for resonance #');
end

beep
pause(0.25)
beep
T2=input('Finishing Temperature in deg. C : ');
P2=input('Finishing gauge Pressure in bars (-1 for vacuum) : ');
T2temp=T2;
P2temp=P2;
time=fix(clock);
timestamp=num2str(time(6)+1e2*time(5)+1e4*time(4)+1e6*time(3)+1e8*time(2)+1e10*time(1));
Rs=num2str(R);

 % list of applicable file extensions to be saved.  Make sure these match
 % the previous list.
    if pressures==1
        filename=strcat(Rs, '_Ar_30mbar_pure');
    elseif pressures==2
        filename=strcat(Rs, '_Ar_4bars_quarterpercent');
    elseif pressures==3
        filename=strcat(Rs, '_Ar_8bars_quarterpercent');
    elseif pressures==4
        filename=strcat(Rs, '_Ar_12bars_quarterpercent');
    elseif pressures==5
        filename=strcat(Rs, '_Ar_8bars_16thpercent');
    elseif pressures==6
        filename=strcat(Rs, '_Ar_12bars_16thpercent');   
    elseif pressures==7
        filename=strcat(Rs, '_Ar_120mbar_pure');
    elseif pressures==8
        filename=strcat(Rs, '_Ar_12bars_1percent');
    elseif pressures==9
        filename=strcat(Rs, '_Ar_8bars_1percent');
    elseif pressures==10
        filename=strcat(Rs, '_Ar_6bars_1percent');
    elseif pressures==11
        filename=strcat(Rs, '_Ar_4bars_1percent');
    elseif pressures==12
        filename=strcat(Rs, '_Ar_2bars_1percent');
    elseif pressures==13
        filename=strcat(Rs, '_Ar_1bar_1percent');   
    elseif pressures==14
        filename=strcat(Rs, '_Ar_halfbar_1percent');           
    end      
clear *Str *0
save (filename)
G=0;
    end
end

pause(0.25)
beep    % alert the user that the measurements are complete
pause(0.25)
beep
pause(0.25)
beep
pause(0.25)
beep