close all
instrreset
clear all
format long

% code for dielectrically matching measurements using the HP8564E spectrum
% analyzer and HP83650B swept signal generator

% The user list the appropriate file name extensions and the resonance
% numbers to be matched.  Be careful to use unique file name extensions, or
% previous data can be over-written.  There are many different "states"
% that assist in automating the process and assuring correct retrieval of data. 
% For information on what each command does, see the findandgetdata_Slow file.

G=2;
bypass=0;       % set to 1 to bypass the requirement of having the 
% resonance synchronized sweeps line up at the target frequency.  This is
% used when the synchronization shifts to a slightly different frequency
% relative to the un-synchronized version between the test gas and
% dielectric matching.

KaAfter=3;
for R=85:89     % used for K/Ka-band Fabry-Perot resonator measurements
%for R=60:70    % used for small cylindrical cavity resonator measurements
    
pressures=6;    % choose measurement to dielectrically match
    Rstr=num2str(R);
 Z=0;  
 % list of applicable file extensions
    if pressures==1
        if KaAfter==1
            filenm=strcat(Rstr, '_nh3_12bars_1percent');
        elseif KaAfter==2
            filenm=strcat(Rstr, '_nh3_12bars_quarterpercent');
        else
            filenm=strcat(Rstr, '_nh3_12bars_16thpercent');
        end
        
    elseif pressures==2
        if KaAfter==1
            filenm=strcat(Rstr, '_nh3_8bars_1percent');
        elseif KaAfter==2
            filenm=strcat(Rstr, '_nh3_8bars_quarterpercent');            
        else
            filenm=strcat(Rstr, '_nh3_8bars_16thpercent');
        end        
    elseif pressures==3
        if KaAfter==1
            filenm=strcat(Rstr, '_nh3_4bars_1percent');
        elseif KaAfter==2
            filenm=strcat(Rstr, '_nh3_4bars_quarterpercent');            
        else
            filenm=strcat(Rstr, '_nh3_6bars_1percent');
        end
    elseif pressures==4
        if KaAfter==1
            filenm=strcat(Rstr, '_nh3_2bars_1percent');
        elseif KaAfter==2
            filenm=strcat(Rstr, '_nh3_30mbar_pure');  
        else
            filenm=strcat(Rstr, '_nh3_120mbar_pure');
        end
    elseif pressures==5
        if KaAfter==1
            filenm=strcat(Rstr, '_nh3_1bar_1percent');
        elseif KaAfter==2
            filenm=strcat(Rstr, '_nh3_halfbar_1percent');  
        else
            filenm=strcat(Rstr, '_nh3_halfbar_premix');
        end
    elseif pressures==6
        if KaAfter==1
            filenm=strcat(Rstr, '_nh3_3bars_premix');
        elseif KaAfter==2
            filenm=strcat(Rstr, '_nh3_2bars_premix'); 
        else
            filenm=strcat(Rstr, '_nh3_1bar_premix');
        end
    elseif pressures==7
        if KaAfter==1
            filenm=strcat(Rstr, '_nh3_eighthbar_2');
        else
            filenm=strcat(Rstr, '_nh3_eighthbar');
        end
    elseif pressures==8
        if KaAfter==1
            filenm=strcat(Rstr, '_nh3_sixteenthbar_2');
        else
            filenm=strcat(Rstr, '_nh3_sixteenthbar');
        end
    elseif pressures==9
        if KaAfter==1
            filenm=strcat(Rstr, '_nh3_32ndbar_2');
        else
            filenm=strcat(Rstr, '_nh3_32ndbar');
        end
    elseif pressures==10
        if KaAfter==1
            filenm=strcat(Rstr, '_nh3_quarterbar_100percent_2');
        else
            filenm=strcat(Rstr, '_nh3_quarterbar_100percent');
        end        
    end   
  if (R==60||R==61||R==65)
      
      % uncomment the following for situations where those resonances did
      % not yield usable data
%  elseif (pressures==2 && KaAfter==2) && (R==61 || R==62 || R==65 || R==66 || R==67 || R==68)
%  elseif (pressures==3 && KaAfter==2) && (R==61 || R==62 || R==65 || R==66 || R==67 || R==68)
%  elseif (pressures==1 && KaAfter==0) && (R==61 || R==62 || R==65 || R==66 || R==67 || R==68)
%  elseif (pressures==2 && KaAfter==0) && (R==61 || R==62 || R==68)
%  elseif (pressures==3 && KaAfter==0) && (R==61 || R==62)
%  elseif pressures==4 && (R==60 || R==61 || R==62 || R==65 || R==66 || R==67 || R==68)
  else

    load (filenm)
    Boriginal=B(:,1);
    Coriginal=C(:,2);
    BNH3=B;
    CNH3=C;
    Bwideoriginal=Bwide(:,1);
    figure(10000*R+KaAfter+10*pressures)
    plot(freqwide,Bwideoriginal,'r')
    SweepTime2=40;

cntr=0;
while cntr<1
if R > 0 && R < 92
    instrreset
sig = gpib('ni',0,19);
SA = gpib('ni',0,18);
WFG = gpib('ni',0,10);
SA.InputBufferSize=4300;

    % process original test gas measurement to find center frequency
[BW3dBa BW3dBe PeakFa_0 PeakFe Qa Qe Levela Levele Asymma Asymme]=resprocessSA(BNH3,numswp2,freq,RBW,0);
[BW3dBa BW3dBe PeakFa PeakFe Qa Qe Levela Levele Asymma Asymme]=resprocessSAsync(CNH3,numswp,freq,RBW);



clear B C
fopen(SA)
fopen(sig)
fopen(WFG)
set(SA,'Timeout',50)
    if R==50
        beep
        pause(0.25)
        beep
        fprintf(sig, 'POW:STAT OFF')
        input('connect large resonator with Pasternack K-band isolator')
    end  
    if R==60
        beep
        pause(0.25)
        beep
        fprintf(sig, 'POW:STAT OFF')
        input('connect small resonator with Pasternack K-band isolator')
    end  

fprintf(sig, 'POW:STAT ON')

if R>70 && R<85     % unused resonances
    fprintf(sig, 'POW:LEVEL %f', pwr-10)
else
    fprintf(sig, 'POW:LEVEL %f', pwr)
end
fprintf(WFG, 'APPL:SQU 0.55, 0.5, 0.25') %turn trigger off
fprintf(sig, 'SWE:FREQ:GEN ANAL')
fprintf(sig, 'SWE:FREQ:TIME 1')
fprintf(sig, 'INIT:CONT 1')
fprintf(SA, 'CONTS;')
fprintf(SA, 'TM EXT')
fprintf(sig, 'TRIG:SOUR EXT;') 

fprintf(SA, 'DET POS;')
fprintf(SA, 'AT 0;')
fprintf(SA, 'RL -10;')
fprintf(SA, 'LG 10DB;')

fprintf(sig, 'FREQ:CENT %f', CenterFreq)
fprintf(sig, 'FREQ:SPAN %f', Span*10*1.015)
pause(0.5)
fprintf(sig, 'FREQ:SPAN %f', Span*10*1.015)
fprintf(SA, 'CF %f;', CenterFreq)
fprintf(SA, 'SP %f;', Span*10)
fprintf(SA, 'RB %f;', RBW2)
fprintf(SA, 'VB %f;', VBW2)
fprintf(SA, 'ST %f;', 0.975)
fprintf(SA, 'CONTS;')
fprintf(WFG, 'APPL:SQU 0.55, 2.5, 1.25')

if G==2 % helps to locate first resonance to be matched.  The others won't be far off after this is done.
Z=input('zoom?');
end

fprintf(SA, 'ST %f;', SweTime)
fprintf(sig, 'FREQ:CENT %f', CenterFreq)
fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
pause(0.5)
fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
fprintf(SA, 'CF %f;', CenterFreq)
fprintf(SA, 'SP %f;', Span)
fprintf(SA, 'ST %f;', SweTime)
fprintf(SA, 'MKF %f;', PeakFa)
pause(7)
fprintf(SA,'TDF P;TRA?;')
fprintf(SA,'CONTS;')
A = fscanf(SA);
B = strread(A,'%f','delimiter',',');
p=max(B);
LevelR = p+3-rem(p,1);
fprintf(SA, 'RL %f;', LevelR)
fprintf(SA, 'LG 2DB;')

tog=0;
i=1;
while i<2
fprintf(SA,'SNGLS;TS;')
fprintf(SA,'TDF P;TRA?;')
fprintf(SA,'CONTS;')
A = fscanf(SA);
B = strread(A,'%f','delimiter',',');
q=min(B);
p=max(B);

    if q~=LevelR-20 && p<LevelR
        i=i+1;
    elseif p>=LevelR && q==LevelR-20
    LevelR=LevelR+1;
    fprintf(SA, 'RL %f;', LevelR)
    i=i+1;
    elseif p>=LevelR && q<LevelR-19 && tog>2
    LevelR=LevelR+1;
    fprintf(SA, 'RL %f;', LevelR)
    i=i+1;
    elseif p>=LevelR  
    LevelR=LevelR+1;
    fprintf(SA, 'RL %f;', LevelR)    
    tog=tog+1;
    else
    LevelR=LevelR-1;
    fprintf(SA, 'RL %f;', LevelR)
    tog=tog+1;
    end    

end
% process sweep to find amplitude
[BW3dBa BW3dBe PeakFa2 PeakFe Qa Qe Levela Levele Asymma Asymme]=resprocessSAsync(B,1,freq,RBW);
if p-q<11
    fprintf(SA, 'LG 1DB;')
end

Amp = Levela+1-rem(Levela,1);
fprintf(SA, 'RL %f;', Amp)

Thresh=Amp-10;


while Thresh<Amp-9
for i=1:5
    sweep = i
    fprintf(SA,'SNGLS;TS;')
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    fprintf(SA, 'CONTS;')
    C(:,i)=strread(A,'%f','delimiter',',');
    peak(i)=max(C(:,i));
end
Thresh=max(peak)
end
[BW3dBa BW3dBe PeakFa2 PeakFe Qa Qe Levela Levele Asymma Asymme]=resprocessSAsync(C,5,freq,RBW);
Gg=0;
if PeakFa2>PeakFa
    state0=1;
elseif PeakFa2<PeakFa
    state0=2;
else
    state0=0;
end
if bypass==1
    i=2;
    G=1;
else
    i=1;
end
while i<2

if abs(PeakFa2-PeakFa)<Span/300     % target frequency has been reached
    diff=15000;
    x=[1:1:diff];
    tone=[sin(x/10)/6 sin(x/10)/6];
    sound(tone,diff*2)      % play confirmation tone
    pause(1)
    i=i+1;

state0=3;
else
    fclose(SA)
    t=0.5;
    if PeakFa2~=PeakFa
        diff=4000*abs(log10(abs((PeakFa2-PeakFa)/Span)));
    else
        diff=15000;
    end
    x=[1:1:diff];
    if Gg==0
    if PeakFa2>PeakFa
        beep
        pause(0.25)
        disp('add gas')
        if Z==1
        i=i+1;
        end
    else
        beep
        pause(0.25)
        beep
        pause(0.25)
        disp('remove gas')
        if Z==1
        i=i+1;
        end
    end
    end
    sound(sin(x/10)/3,diff/t)
    pause(5)
    fopen(SA)
    G=1;
    fprintf(SA,'SNGLS;TS;')
    fprintf(SA,'TDF P;TRA?;')
    fprintf(SA,'CONTS;')
    A = fscanf(SA);
    B = strread(A,'%f','delimiter',',');
    [BW3dBa BW3dBe PeakFa2 PeakFe Qa Qe Levela Levele Asymma Asymme]=resprocessSAsync(B,1,freq,RBW);
    if PeakFa2>PeakFa
       state1=1;
    elseif PeakFa2<PeakFa
       state1=2;
    else
       state1=0;
    end
    if state0==state1
        Gg=1;
    else
        Gg=0;
        state0=state1;
    end
end
end
if G>0
    fclose(SA)
    T1=input('Starting Temperature in deg. C : ');
    P1=input('Starting gauge Pressure in bars (-1 for vacuum) : ');
    fopen(SA)
else
    T1=T2temp;
    P1=P2temp;
end

fprintf(SA, 'RB %f;', RBW)
fprintf(SA, 'VB %f;', VBW)
fprintf(SA, 'TM FREE;')
fprintf(sig, 'TRIG:SOUR IMM;')
fprintf(SA, 'ST %f;', 40)
fprintf(sig, 'SWE:FREQ:TIME 75e-3')
fprintf(SA, 'CONTS;')
fprintf(SA,'CF?;')
CenterFreq = fscanf(SA, '%f');
fprintf(SA,'AT?;')
Attenuation = fscanf(SA, '%f');
fprintf(SA,'DET?;')
Detector = fscanf(SA, '%c');
fprintf(SA,'SP?;')
Span = fscanf(SA, '%f');
fprintf(SA,'RB?;')
RBW = fscanf(SA, '%f');
fprintf(SA,'VB?;')
VBW = fscanf(SA, '%f');
fprintf(SA,'RL?;')
RL = fscanf(SA, '%f');
fprintf(SA,'LG?;')
LG = fscanf(SA, '%f');
freq=linspace(CenterFreq-Span/2, CenterFreq+Span/2, 601);

if R==67||R==68||R==66||R==61||R==64||R==62  % set a number of default stabilization 
% wasted sweeps for resonances that require or frequencies that take time to stabilize
stablesweepnum=8;
elseif R==85||R==86
stablesweepnum=10;
elseif R==69
stablesweepnum=9;
end

fprintf(sig, 'INIT:CONT 1')
if (R==66||R==67||R==68||R==85||R==806||R==69||R==62) %&&KaAfter==1

while i<=stablesweepnum
    longsweep85 = i
    fprintf(sig, 'INIT:CONT 1')
    fprintf(SA,'SNGLS;')
    pause(SweepTime2+5)
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    B(:,i)=strread(A,'%f','delimiter',',');
    fprintf(SA, 'CONTS;')
    gooddata=0;
    for k=1:601
        if B(k,i)>RL-10*LG
            gooddata=gooddata+1;
        end
    end
    if gooddata >= 130
        i=i+1;
    else
        fprintf(sig, 'SWE:MODE MAN')
        fprintf(sig, 'FREQ:CENT %f', CenterFreq)
        pause(1)
        fprintf(sig, 'FREQ:CENT %f', CenterFreq)
        fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
        pause(1)
        fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
        pause(1)
        fprintf(sig, 'TRIG:SOUR IMM;')
        pause(1)
        fprintf(sig, 'INIT:CONT 0')
        pause(1)
        fprintf(sig, 'INIT:CONT 1')
        fprintf(sig, 'SWE:MODE AUTO')
    end
    if i==2 && bypass~=1
        [BW3dBa BW3dBe PeakFa_int PeakFe Qa Qe Levela Levele Asymma Asymme]=resprocessSAspline(B(:,1),1,freq,RBW);
        if (PeakFa_int-PeakFa_0)>Span/200
            cntr=0;
            i=1;
            figure(R)
            if R>70 && R<85
                plot(freq,B(:,1)+10,'r')
            else
                plot(freq,B(:,1),'r')
            end
            hold on
            plot(freq,Boriginal,'b')
            beep
            pause(0.25)
            beep
            input('Match too high. Add gas, repeat measurement.')
            P1=input('Starting gauge Pressure in bars (-1 for vacuum) : ');
        elseif (PeakFa_0-PeakFa_int)>Span/200
            cntr=0;
            i=1;    
            figure(R)
            if R>70 && R<85
                plot(freq,B(:,1)+10,'r')
            else
                plot(freq,B(:,1),'r')
            end
            hold on
            plot(freq,Boriginal,'b')
            beep
            pause(0.25)
            beep
            input('Match too low. Remove gas, repeat measurement.')
            P1=input('Starting gauge Pressure in bars (-1 for vacuum) : ');
        end
    end
end
end
clear B
i=1;
while i<=numswp2
    longsweep = i
    fprintf(sig, 'INIT:CONT 1')
    fprintf(SA,'SNGLS;')
    pause(SweepTime2+5)
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    B(:,i)=strread(A,'%f','delimiter',',');
    fprintf(SA, 'CONTS;')
    gooddata=0;
    for k=1:601
        if B(k,i)>RL-10*LG
            gooddata=gooddata+1;
        end
    end
    if gooddata >= 130
        i=i+1;
    else
        fprintf(sig, 'SWE:MODE MAN')
        fprintf(sig, 'FREQ:CENT %f', CenterFreq)
        pause(1)
        fprintf(sig, 'FREQ:CENT %f', CenterFreq)
        fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
        pause(1)
        fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
        pause(1)
        fprintf(sig, 'TRIG:SOUR IMM;')
        pause(1)
        fprintf(sig, 'INIT:CONT 0')
        pause(1)
        fprintf(sig, 'INIT:CONT 1')
        fprintf(sig, 'SWE:MODE AUTO')
    end
    if i==2 && bypass~=1
        [BW3dBa BW3dBe PeakFa_int PeakFe Qa Qe Levela Levele Asymma Asymme]=resprocessSAspline(B(:,1),1,freq,RBW);
        if (PeakFa_int-PeakFa_0)>Span/200
            cntr=0;
            i=1;
            figure(R)
            plot(freq,B(:,1),'r')
            hold on
            plot(freq,Boriginal,'b')
            hold off
            beep
            pause(0.25)
            beep
            input('Match too high. Add gas, repeat measurement.')
            P1=input('Starting gauge Pressure in bars (-1 for vacuum) : ');
        elseif (PeakFa_0-PeakFa_int)>Span/200
            cntr=0;
            i=1;    
            figure(R)
            plot(freq,B(:,1),'r')
            hold on
            plot(freq,Boriginal,'b')
            hold off
            beep
            pause(0.25)
            beep            
            input('Match too low. Remove gas, repeat measurement.')
            P1=input('Starting gauge Pressure in bars (-1 for vacuum) : ');
        end
    end    
end

fprintf(SA, 'ST %f;', SweTime)
fprintf(SA, 'RB %f;', RBW2)
fprintf(SA, 'VB %f;', VBW)
fprintf(WFG, 'APPL:SQU 0.55, 0.5, 0.25') %turn trigger off
fprintf(sig, 'SWE:FREQ:GEN ANAL')
fprintf(sig, 'SWE:FREQ:TIME 1')
fprintf(sig, 'INIT:CONT 1')
fprintf(SA, 'CONTS;')
fprintf(SA, 'TM EXT')
fprintf(sig, 'TRIG:SOUR EXT;') 
fprintf(WFG, 'APPL:SQU 0.55, 2.5, 1.25')

    threshtol=0.2

i=1;
errcnt=0;
while i<numswp+1
    sweep = i
    fprintf(SA,'SNGLS;TS;')
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    fprintf(SA, 'CONTS;')
    C(:,i)=strread(A,'%f','delimiter',',');
    peak2=max(C(:,i));
    
% uncomment the following section to take synchronized sweeps
    
    %if peak2>(Thresh-threshtol) && C(420,i)~=(RL-10) && C(180,i)~=(RL-10)
        i=i+1;
    %else
%         if errcnt==5
%             Thresh=Amp-10;
%             pause(10)
%             errcnt=0;
%             while Thresh<Amp-9
%                 for i=1:5
%                     sweep = i
%                     fprintf(SA,'SNGLS;TS;')
%                     fprintf(SA,'TDF P;TRA?;')
%                     A = fscanf(SA);
%                     fprintf(SA, 'CONTS;')
%                     C(:,i)=strread(A,'%f','delimiter',',');
%                     peak(i)=max(C(:,i));
%                 end
%             Thresh=max(peak)
%             end
%             i=1;
%         end
        
       % errcnt=errcnt+1
       % beep
    %end
end



fprintf(sig, 'FREQ:CENT %f', freqwide(301))
fprintf(sig, 'FREQ:SPAN %f', 100e6*1.015)
pause(0.5)
fprintf(sig, 'FREQ:SPAN %f', 100e6*1.015)
fprintf(SA, 'CF %f;', freqwide(301))
fprintf(SA, 'SP %f;', 100e6)
fprintf(SA, 'RL -10;')
fprintf(SA, 'LG 10DB;')
fprintf(SA, 'RB 2e6')
fprintf(SA, 'ST 0.975S;')
fprintf(SA, 'CONTS;')
pause(7)
fprintf(SA,'SNGLS;TS;')
fprintf(SA,'TDF P;TRA?;')
A = fscanf(SA);
Bwide=strread(A,'%f','delimiter',',');
fprintf(SA, 'CONTS;')

% uncomment the following line to use synchronized sweeps for final data processing
%[BW3dBa BW3dBe PeakFa PeakFe Qa Qe Levela Levele Asymma Asymme]=resprocessSAsync(C,numswp,freq,RBW);
[BW3dBa BW3dBe PeakFa_1 PeakFe Qa Qe Levela Levele Asymma Asymme]=resprocessSA(B,numswp2,freq,RBW,0);
    figure(100*R+KaAfter+10*pressures)
    if R>70 && R<85
        B=B+10;
        Bwide=Bwide+10;
        C=C+10;
    end
    plot(freq,B)
    hold on
    plot(freq,C)
    plot(freq,Boriginal,'b')
    plot(freq,Coriginal,'b')
if (PeakFa_0-PeakFa_1)>Span/150 && bypass~=1
    disp('Match too high. Add gas, repeat measurement.')
    cntr=0;
    G=1;  
elseif (PeakFa_1-PeakFa_0)>Span/150 && bypass~=1
    disp('Match too low. Remove gas, repeat measurement.')
    cntr=0;
    G=1;

% Check to see if synchronized data is correct
    
% elseif (PeakFa2-PeakFa)>Span/50
%     disp('Sync match too high. Add gas, repeat measurement.')
%     cntr=0;
%     G=1;
% elseif (PeakFa-PeakFa2)>Span/50
%     disp('Sync match too low. Remove gas, repeat measurement.')
%     cntr=0;
%     G=1;
else

    cntr=1;
    
    figure(10000*R+KaAfter+10*pressures)
    hold on
    plot(freqwide,Bwide)
end

fclose(WFG)
fclose(SA)
fclose(sig)
else
    disp('invalid input for resonance #');
end
end
beep
pause(0.25)
beep
T2=input('Finishing Temperature in deg. C : ');
P2=input('Finishing gauge Pressure in bars (-1 for vacuum) : ');
        T2temp=T2;
        P2temp=P2;
time=fix(clock);
timestamp=num2str(time(6)+1e2*time(5)+1e4*time(4)+1e6*time(3)+1e8*time(2)+1e10*time(1));
Rs=num2str(R);

 % list of applicable file extensions to be saved.  Make sure these match
 % the previous list.
    if pressures==1
        if KaAfter==1
            filename=strcat(Rs,'_Ar_12bars_1percent');
        elseif KaAfter==2
            filename=strcat(Rs, '_Ar_12bars_quarterpercent');            
        else
            filename=strcat(Rs,'_Ar_12bars_16thpercent');
        end
    elseif pressures==2
        if KaAfter==1
            filename=strcat(Rs,'_Ar_8bars_1percent');
        elseif KaAfter==2
            filename=strcat(Rs, '_Ar_8bars_quarterpercent');              
        else
            filename=strcat(Rs,'_Ar_8bars_16thpercent');
        end
    elseif pressures==3
        if KaAfter==1
            filename=strcat(Rs,'_Ar_4bars_1percent');
        elseif KaAfter==2
            filename=strcat(Rs, '_Ar_4bars_quarterpercent');              
        else
            filename=strcat(Rs,'_Ar_6bars_1percent');
        end
    elseif pressures==4
        if KaAfter==1
            filename=strcat(Rs,'_Ar_2bars_1percent');
        elseif KaAfter==2
            filename=strcat(Rs, '_Ar_30mbar_pure');     
        else
            filename=strcat(Rs,'_Ar_120mbar_pure');
        end
    elseif pressures==5
        if KaAfter==1
            filename=strcat(Rs,'_Ar_1bar_1percent');
        elseif KaAfter==2
            filename=strcat(Rs, '_Ar_halfbar_1percent');  
        else
            filename=strcat(Rs,'_Ar_halfbar_premix');
        end
    elseif pressures==6
        if KaAfter==1
            filename=strcat(Rs,'_Ar_3bars_premix');
        elseif KaAfter==2
            filename=strcat(Rs, '_Ar_2bars_premix');  
        else
            filename=strcat(Rs,'_Ar_1bar_premix');
        end
    elseif pressures==7
        if KaAfter==1
            filename=strcat(Rs,'_Ar_eighthbar_2');
        else
            filename=strcat(Rs,'_Ar_eighthbar');
        end  
    elseif pressures==8
        if KaAfter==1
            filename=strcat(Rs,'_Ar_sixteenthbar_2');
        else
            filename=strcat(Rs,'_Ar_sixteenthbar');
        end
    elseif pressures==9
        if KaAfter==1
            filename=strcat(Rs,'_Ar_32ndbar_2');
        else
            filename=strcat(Rs,'_Ar_32ndbar');
        end  
    elseif pressures==10
        if KaAfter==1
            filename=strcat(Rs,'_Ar_quarterbar_100percent_2');
        else
            filename=strcat(Rs,'_Ar_quarterbar_100percent');
        end          
    end
clear *Str *0 tone x BNH3 CNH3      % clear excess unneeded data
save (filename)
G=0;

end
end

pause(0.25)
beep    % alert the user that the measurements are complete
pause(0.25)
beep
pause(0.25)
beep
pause(0.25)
beep