close all
instrreset
clear all

% code for tracking the Q and center frequency of the large cavity resonator

% The user specifies the approximate resonant frequencies to be measured,
% while cnt2 iterates through those resoances and cnt iterates as a
% function of time.  The frequencies should be scaled in line 52 so that they
% can be more easily located.  The file name must be changed in line 210.

% If the code stops for whatever reason, while equilibration is still
% occurring, it should be restarted after commenting out lines 3, 47, and
% changing the first iterator of line 48 to match up with what's already
% been measured.

%load Qtrack_bigres_1percent_3bars  % used if trying to reload data to
                                    % restart tracking (insert correct filename)
format long
numpoints=1601;
    numswp=10;
    NA = gpib('ni',0,17);
    NA.InputBufferSize=250000;
    fclose(NA)
    fopen(NA)
    fprintf(NA, ':OUTP ON')
    fprintf(NA, ':SENS1:CORR:CLE')              % clear calibration correction coefficient
    fprintf(NA, ':SENS1:SWE:DEL 0.01')          % sweep delay set to 10ms
    fprintf(NA, ':SENS1:SWE:GEN STEP')          % sweep set to stepped mode
    fprintf(NA, ':SENS1:SWE:POIN 1601')         % set # of points
    fprintf(NA, ':SOUR1:POW 0')                 % set source power to 0 dBm
    fprintf(NA, ':CALC1:FORM MLOG')             % log magnitude format
    IFBW=10000;
    fprintf(NA, ':SENS1:BWID %f;', IFBW)            % Set IF bandwidth
    
    bigspan=100e6;
    FrelistGHz=[1.51065 1.81651 2.23507 3.76203 6.35851 6.35851];
    zoomspan=10e6;
    Rlist=[1 2 3 9 13 17];


        beep
        pause(0.25)
        beep
T1=input('Starting Temperature in deg. C : ');
P1=input('Starting gauge Pressure in bars (-1 for vacuum) : ');
starttime=fix(clock);
for cnt=1:1200
for cnt2=1:3
R=Rlist(cnt2);
    numswp=10;
    F=FrelistGHz(cnt2)*1e9*150840/151065;   % frequencies scaled to match approximate range of locations

fprintf(NA, ':CALC1:PAR1:DEF S12')              % measure S(1,2)
fprintf(NA, ':SENS1:FREQ:CENT %f;', F)  % set center frequency
fprintf(NA, ':SENS1:FREQ:SPAN %f;', bigspan)    % set frequency span
fprintf(NA, ':SENS1:SWE:TIME:AUTO ON')          % turn on auto sweep time
fprintf(NA, ':CALC1:MARK1:FUNC:PEXC 0.0')       % set peak excursion to 0 dB
fprintf(NA, ':SENS1:SWE:TIME?')                 % query sweep time
Swetime = fscanf(NA, '%f');
pause(0.5+Swetime)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')         % set display power axis to auto scale
fprintf(NA, ':CALC1:MARK1:FUNC:TYPE PEAK')      % specify marker type to peak
fprintf(NA, ':CALC1:MARK1:FUNC:EXEC')           % search for peak
fprintf(NA, ':CALC1:MARK1:SET CENT')            % make the center frequency that of the peak

fprintf(NA, ':SENS1:SWE:POIN %i;', 1601)         % set # of points
pause(0.5+Swetime)
fprintf(NA, ':SENS1:FREQ:DATA?')            % query frequency data
faxiswideStr = fscanf(NA);
faxiswide=strread(faxiswideStr,'%f','delimiter',',');
fprintf(NA, ':CALC1:DATA:FDAT?')
S12wideStr = fscanf(NA);
S12wide0=strread(S12wideStr,'%f','delimiter',',');
CentFwide(cnt,cnt2)=faxiswide(801);

fprintf(NA, ':CALC1:PAR1:DEF S11')          % measure S(1,1)
pause(Swetime+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:DATA:FDAT?')
S11wideStr = fscanf(NA);
S11wide0=strread(S11wideStr,'%f','delimiter',',');

for i=1:3202
if mod((i+1),2)==0
    S11wide((i+1)/2)=S11wide0(i);
    S12wide((i+1)/2)=S12wide0(i);
end
end
S12big(cnt,cnt2,:)=S12wide;
S11big(cnt,cnt2,:)=S11wide;
fprintf(NA, ':SENS1:FREQ:SPAN %f;', zoomspan);    % set frequency span
fprintf(NA, ':CALC1:PAR1:DEF S12')              % measure S(1,2)
pause(Swetime+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:MARK1:FUNC:TYPE PEAK')      % specify marker type to peak
fprintf(NA, ':CALC1:MARK1:FUNC:EXEC')           % search for peak
fprintf(NA, ':CALC1:MARK1:SET CENT')            % make the center frequency that of the peak
pause(Swetime+0.5)
fprintf(NA, ':CALC1:DATA:FDAT?')
S21narrowStr = fscanf(NA);
S21narrow0=strread(S21narrowStr,'%f','delimiter',',');
fprintf(NA, ':SENS1:FREQ:DATA?')            % query frequency data
faxisnarrowStr = fscanf(NA);
faxisnarrow=strread(faxisnarrowStr,'%f','delimiter',',');
for i=1:3202
if mod((i+1),2)==0
    S21narrow((i+1)/2)=S21narrow0(i);
end
end
[bw3db PeakF]=quickprocessNA(S21narrow,faxisnarrow);
bw3db=bw3db-rem(bw3db,1e4);
PeakF=PeakF-rem(PeakF,1e3);

%Zoomed In
fprintf(NA, ':SENS1:FREQ:SPAN %f;', bw3db*3)    % set frequency span
fprintf(NA, ':SENS1:FREQ:CENT %f;', PeakF)      % set center frequency
fprintf(NA, ':SENS1:SWE:POIN %i;', numpoints)   % set # of points
fprintf(NA, ':SENS1:SWE:TIME?')                 % query sweep time
Swetime2 = fscanf(NA, '%f');
pause(Swetime2+0.5)

fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:MARK1:FUNC:TYPE PEAK')      % specify marker type to peak
fprintf(NA, ':CALC1:MARK1:FUNC:EXEC')           % search for peak
fprintf(NA, ':CALC1:MARK1:SET CENT')            % make the center frequency that of the peak
pause(Swetime2+0.5)
fprintf(NA, ':SENS1:FREQ:DATA?')                % query frequency data
faxisStr = fscanf(NA);
faxis=strread(faxisStr,'%f','delimiter',',');


pause(Swetime2+0.5)
for j=1:numswp                                  
    fprintf(NA, ':CALC1:DATA:FDAT?')
    S12Str = fscanf(NA);
    S120=strread(S12Str,'%f','delimiter',',');
    for i=1:2*numpoints
        if mod((i+1),2)==0
            S12((i+1)/2,j)=S120(i);
        end
    end
    pause(Swetime2+.1)
end

fprintf(NA, ':CALC1:PAR1:DEF S21')              % measure S(2,1)
pause(Swetime2+0.5)
for j=1:numswp                                  
    fprintf(NA, ':CALC1:DATA:FDAT?')
    S21Str = fscanf(NA);
    S210=strread(S21Str,'%f','delimiter',',');
    for i=1:2*numpoints
        if mod((i+1),2)==0
            S21((i+1)/2,j)=S210(i);
        end
    end
    pause(Swetime2+.1)
end

% process sweeps
[BW3dBa12(cnt,cnt2,:) BW3dBe12(cnt,cnt2,:) PeakFa12(cnt,cnt2) PeakFe12(cnt,cnt2) Qa12(cnt,cnt2,:) Qe12(cnt,cnt2,:) Levela12(cnt,cnt2) Levele12(cnt,cnt2) Asymma12(cnt,cnt2) Asymme12(cnt,cnt2)]=NAprocess(S12,numswp,faxis);
[BW3dBa21(cnt,cnt2,:) BW3dBe21(cnt,cnt2,:) PeakFa21(cnt,cnt2) PeakFe21(cnt,cnt2) Qa21(cnt,cnt2,:) Qe21(cnt,cnt2,:) Levela21(cnt,cnt2) Levele21(cnt,cnt2) Asymma21(cnt,cnt2) Asymme21(cnt,cnt2)]=NAprocess(S21,numswp,faxis);

stoptime=fix(clock);

timestamp(cnt,cnt2)=stoptime(6)+1e2*stoptime(5)+1e4*stoptime(4)+1e6*stoptime(3)+1e8*stoptime(2)+1e10*stoptime(1);
time(cnt,cnt2)=etime(stoptime,starttime);

clear *Str *0
figure(10*R)
subplot(2,1,1)
errorbar(time(:,cnt2)/3600,Qa12(:,cnt2,1), Qe12(:,cnt2,1),'rx')
hold on
errorbar(time(:,cnt2)/3600,Qa21(:,cnt2,1), Qe21(:,cnt2,1),'bx')
hold off
if cnt2==1  % set appropriate labels for whichever resonances are used
    ylabel('Q of 1.51 GHz resonance')
elseif cnt2==2
    ylabel('Q of 1.82 GHz resonance')
elseif cnt2==3
    ylabel('Q of 2.23 GHz resonance')
elseif cnt2==4
    ylabel('Q of 3.76 GHz resonance')
elseif cnt2==5
    ylabel('Q of 5.09 GHz resonance')
elseif cnt2==6
    ylabel('Q of 6.36 GHz resonance')
elseif cnt2==7
    ylabel('Q of 5.42 GHz resonance')
end
xlabel('Time since gas added (hrs)')
legend('from S12','from S21',2)

subplot(2,1,2)
errorbar(time(:,cnt2)/3600,PeakFa12(:,cnt2)/1e9, PeakFe12(:,cnt2)/1e9,'rx')
hold on
errorbar(time(:,cnt2)/3600,PeakFa21(:,cnt2)/1e9, PeakFe21(:,cnt2)/1e9,'bx')
hold off
ylabel('Center Frequency (GHz)')



xlabel('Time since gas added (hrs)')
legend('from S12','from S21',2)

if cnt2==3  % save the file after each iteration of cnt
% all the pertinent data are saved including the wide sweeps of S11 and S12
% which can be used to create animations showing how the resonance moves
% with time
    save Qtrack_bigres_nh3_halfbar_1percent timestamp T1 P1 BW3dBa12 BW3dBe12 PeakFa12 PeakFe12 Qa12 Qe12 Levela12 Levele12 Asymma12 Asymme12 BW3dBa21 BW3dBe21 PeakFa21 PeakFe21 Qa21 Qe21 Levela21 Levele21 Asymma21 Asymme21 CentFwide S11big S12big time
end

end
pause(60)       % sets the amount of time to kill between iterations to 
% prevent the file size from becoming too large.  If fast tracking is 
% required, comment out this line.
end
fclose(NA)
pause(0.25)
beep
pause(0.25)
beep
pause(0.25)
beep
pause(0.25)
beep