close all
instrreset
clear all

% code for tracking the Q and center frequency of the Fabry-Perot K/Ka-band
% resonator

% similar functionality as Qtrack_smallres, but with different resonances.
% See that file for comments about using this one.

T1=input('Starting Temperature in deg. C : ');
P1=input('Starting gauge Pressure in bars (-1 for vacuum) : ');
starttime=fix(clock);
%load ka_qtrack_nh3_eighthbar_100percent
Flist=[28.489e9];
%Flist=[23.368e9];
Rlist=[87];
pwrlist=[6];
bigspanlist=[100e6];
sigspanlist=[40e6];
for cnt=1:500
for cnt2=1:1
R=Rlist(cnt2)
F=Flist(cnt2);
RBW=1e5;
pwr=pwrlist(cnt2);
bigspan=bigspanlist(cnt2);
SigSpan=sigspanlist(cnt2);
MixN=2;
instrreset

numswp=1;       % number of synchronized sweeps
numswp2=5;      % number of unsynchronized sweeps
    
sig = gpib('ni',0,19);
SA = gpib('ni',0,18);
WFG = gpib('ni',0,10);
SA.InputBufferSize=4300;
fopen(sig)
fopen(SA)
fopen(WFG)
set(SA,'Timeout',50)

SweepTime=0.975;

VBW=RBW/10;
RBW2=RBW*10;
VBW2=RBW2/10;

fprintf(WFG, 'APPL:SQU 0.55, 0.5, 0.25') %turn trigger off
fprintf(SA, 'BLANK TRB;CLRW TRA;')

fprintf(sig, 'POW:STAT ON')
fprintf(sig, 'SWE:FREQ:GEN ANAL')
fprintf(sig, 'SWE:FREQ:TIME 1')
fprintf(sig, 'POW:LEVEL %f', pwr)
fprintf(sig, 'INIT:CONT 1')
fprintf(SA, 'DET POS;')
fprintf(SA, 'AT 0;')
fprintf(SA, 'RL -10;')
fprintf(SA, 'LG 5DB;')

fprintf(sig, 'FREQ:CENT %f', F)
fprintf(sig, 'FREQ:SPAN %f', bigspan*1.015)
pause(0.25)
fprintf(sig, 'FREQ:SPAN %f', bigspan*1.015)
fprintf(SA, 'CF %f;', F)
fprintf(SA, 'SP %f;', bigspan)
fprintf(SA, 'RB 2e6')
fprintf(SA, 'VB %f', VBW2)
fprintf(SA, 'ST 0.975S;')

fprintf(SA, 'CONTS;')

fprintf(SA, 'TM EXT')
fprintf(sig, 'TRIG:SOUR EXT;') 
fprintf(WFG, 'APPL:SQU 0.9, 2.5, 1.25')
pause(7)
fprintf(SA,'SNGLS;TS;')
fprintf(SA, 'MKPK;')
if R==65||(R>49 && R<60)
   beep
   pause(0.25)
   beep
   fclose(SA)
   input('manually tune to resonance')         % manually move marker to desired peak
   fopen(SA)
end
fprintf(SA, 'MKCF;')
fprintf(SA,'CF?;')
F = fscanf(SA, '%f');
CentF(cnt,cnt2)=F;
fprintf(sig, 'FREQ:CENT %f', F)
fprintf(sig, 'FREQ:SPAN %f', 100e6*1.015)
pause(0.25)
fprintf(sig, 'FREQ:SPAN %f', 100e6*1.015)
fprintf(SA, 'SP %f;', 100e6)
fprintf(SA, 'RB 2e6')
fprintf(SA, 'ST 0.975S;')
fprintf(SA, 'CONTS;')
pause(7)
fprintf(SA,'SNGLS;TS;')
fprintf(SA,'TDF P;TRA?;')
A = fscanf(SA);
Bwide=strread(A,'%f','delimiter',',');
fprintf(SA, 'CONTS;')

fprintf(SA, 'SP %f;', SigSpan)
fprintf(sig, 'FREQ:CENT %f', F)
fprintf(sig, 'FREQ:SPAN %f', SigSpan*1.015)
pause(0.25)
fprintf(sig, 'FREQ:SPAN %f', SigSpan*1.015)
fprintf(SA, 'RB %f;', RBW2)
pause(7)
fprintf(SA,'SNGLS;TS;')
fprintf(SA, 'MKPK HI;MKA?;')
AmpSync = fscanf(SA, '%f');
AmpSync = AmpSync+1-rem(AmpSync,1);
fprintf(SA, 'MKCF;')
fprintf(SA,'CF?;')
F = fscanf(SA, '%f');

fprintf(sig, 'FREQ:CENT %f', F)
fprintf(sig, 'FREQ:SPAN %f', SigSpan*1.015)
pause(0.25)
fprintf(sig, 'FREQ:SPAN %f', SigSpan*1.015)

fprintf(SA, 'RL %f;', AmpSync)
fprintf(SA, 'LG 1DB;')
fprintf(SA, 'CONTS;')
pause(7)
fprintf(SA,'SNGLS;TS;')
fprintf(SA,'TDF P;TRA?;')
A = fscanf(SA);
B=strread(A,'%f','delimiter',',');
freq=linspace(F-SigSpan/2, F+SigSpan/2, 601);
freqwide=linspace(F-50e6, F+50e6, 601);
[bw3db PeakF]=quickprocess_sync(B,freq);
bw3db=bw3db-rem(bw3db,1e4);
PeakF=PeakF-rem(PeakF,1e4);

fprintf(SA, 'SP %f;', bw3db*2)
fprintf(SA, 'CF %f;', PeakF)
fprintf(SA, 'ST %f;', SweepTime)
fprintf(sig, 'FREQ:CENT %f', PeakF)
fprintf(sig, 'FREQ:SPAN %f', bw3db*2*1.015)
pause(0.25)
fprintf(sig, 'FREQ:SPAN %f', bw3db*2*1.015)

fprintf(SA, 'CONTS;')
fprintf(SA, 'RL %f;', AmpSync+3)
pause(7)
fprintf(SA,'SNGLS;TS;')
fprintf(SA,'TDF P;TRA?;')
A = fscanf(SA);
B=strread(A,'%f','delimiter',',');
fprintf(SA, 'MKPK HI;MKA?;')
AmpSync2 = fscanf(SA, '%f');
AmpSync2 = AmpSync2+1-rem(AmpSync2,1);

fprintf(SA, 'RL %f;', AmpSync2)
fprintf(SA, 'CONTS;')
freq=linspace(PeakF-bw3db, PeakF+bw3db, 601);
[bw3db PeakF]=quickprocess_sync(B,freq);
bw3db=bw3db-rem(bw3db,1e4);
PeakF=PeakF-rem(PeakF,1e4);

if R==70
    bw3db=bw3db*1.5;
end
SweTime=SweepTime;
if bw3db>(1e6*MixN)
    if bw3db<(1.3e6*MixN)
        bw3db=(1e6*MixN);
    else
        SweTime=0.975;
    end
else
    SweTime=SweepTime;
end

fprintf(SA, 'ST %f;', SweTime)
fprintf(SA, 'CF %f;', PeakF)
fprintf(SA, 'SP %f;', bw3db*2)
fprintf(SA,'CF?;')
PeakF = fscanf(SA, '%f');
fprintf(sig, 'FREQ:CENT %f', PeakF)
fprintf(sig, 'FREQ:SPAN %f', bw3db*2*1.015)
pause(0.25)
fprintf(sig, 'FREQ:SPAN %f', bw3db*2*1.015)

fprintf(SA, 'RB %f;', RBW)
fprintf(SA, 'VB %f', VBW)
fprintf(SA, 'TM FREE;')
fprintf(sig, 'TRIG:SOUR IMM;')
fprintf(sig, 'SWE:FREQ:TIME 0.075;') 
fprintf(SA, 'ST 10;')
fprintf(sig, 'INIT:CONT 1')
fprintf(SA,'SNGLS;TS;')
fprintf(SA,'TDF P;TRA?;')
A = fscanf(SA);
B=strread(A,'%f','delimiter',',');
fprintf(SA, 'MKPK HI;MKA?;')
Amp = fscanf(SA, '%f');
Amp = Amp+1-rem(Amp,1);
fprintf(SA, 'RL %f;', Amp)

fprintf(SA, 'ST 40;')
fprintf(SA,'CF?;')
CenterFreq = fscanf(SA, '%f');
fprintf(SA,'AT?;')
Attenuation = fscanf(SA, '%f');
fprintf(SA,'DET?;')
Detector = fscanf(SA, '%c');
fprintf(SA,'SP?;')
Span = fscanf(SA, '%f');
fprintf(SA,'RB?;')
RBW = fscanf(SA, '%f');
fprintf(SA,'RL?;')
RL = fscanf(SA, '%f');
fprintf(SA,'VB?;')
VBW = fscanf(SA, '%f');
freq=linspace(CenterFreq-Span/2, CenterFreq+Span/2, 601);
figure(R)
plot(freqwide,Bwide)
    
fprintf(sig, 'INIT:CONT 1')
if R==86||R==70||R==85

long_errcnt=0;
q=1;
while q<=0
    long_sweep_stabilizing = q
    fprintf(sig, 'INIT:CONT 1')
    fprintf(SA,'SNGLS;')
    pause(45)
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    B(:,q)=strread(A,'%f','delimiter',',');
    fprintf(SA, 'CONTS;')
    gooddata=0;
    for k=1:601
        if B(k,q)>RL-10
            gooddata=gooddata+1;
        end
    end
    if gooddata >= 130
        q=q+1;
    else
        fprintf(sig, 'SWE:MODE MAN')
        pause(1)
        fprintf(sig, 'FREQ:CENT %f', CenterFreq)
        pause(1)
        fprintf(sig, 'FREQ:CENT %f', CenterFreq)
        fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
        pause(1)
        fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
        pause(1)
        fprintf(sig, 'INIT:CONT 0')
        pause(1)
        fprintf(sig, 'INIT:CONT 1')
        pause(1)
        fprintf(sig, 'SWE:MODE AUTO')
        pause(1)
        fprintf(sig, 'TRIG:SOUR IMM;')
    end
end
clear B
end

long_errcnt=0;
q=1;
while q<=numswp2
    long_sweep = q
    fprintf(sig, 'INIT:CONT 1')
    fprintf(SA,'SNGLS;')
    pause(45)
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    B(:,q)=strread(A,'%f','delimiter',',');
    fprintf(SA, 'CONTS;')
    gooddata=0;
    for k=1:601
        if B(k,q)>RL-10
            gooddata=gooddata+1;
        end
    end
    if gooddata >= 130
        q=q+1;
    else
        fprintf(sig, 'SWE:MODE MAN')
        pause(1)
        fprintf(sig, 'FREQ:CENT %f', CenterFreq)
        pause(1)
        fprintf(sig, 'FREQ:CENT %f', CenterFreq)
        fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
        pause(1)
        fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
        pause(1)
        fprintf(sig, 'INIT:CONT 0')
        pause(1)
        fprintf(sig, 'INIT:CONT 1')
        pause(1)
        fprintf(sig, 'SWE:MODE AUTO')
        pause(1)
        fprintf(sig, 'TRIG:SOUR IMM;')
    end
end

figure(100*R)
plot(freq,B)
fprintf(SA, 'RL %f;', AmpSync2)
fprintf(WFG, 'APPL:SQU 0.55, 2.5, 1.25')
    fprintf(SA, 'TM EXT')
    fprintf(sig, 'TRIG:SOUR EXT;') 
    fprintf(sig, 'SWE:FREQ:TIME 1;') 
    fprintf(SA, 'ST %f;', SweTime)
    fprintf(SA, 'RB %f;', RBW2)
    
    fprintf(sig, 'SWE:FREQ:GEN ANAL')
    fprintf(SA, 'CONTS;')
    fprintf(sig, 'INIT:CONT 1')
Thresh=AmpSync2-10;

while Thresh<AmpSync2-9 
for i=1:3
    sweep = i
    fprintf(SA,'SNGLS;TS;')
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    fprintf(SA, 'CONTS;')
    C(:,i)=strread(A,'%f','delimiter',',');
    peak(i)=max(C(:,i));
end
Thresh=max(peak)
if Thresh >= AmpSync2-0.5
    fprintf(SA, 'RL %f;', AmpSync2+1)
end
end

    threshtol=0.2

i=1;
errcnt=0;
while i<numswp+1
    sweep = i
    fprintf(SA,'SNGLS;TS;')
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    fprintf(SA, 'CONTS;')
    C(:,i)=strread(A,'%f','delimiter',',');
    peak2=max(C(:,i));
    if peak2>(Thresh-threshtol) 
        i=i+1;
    else
        if errcnt==5
            Thresh=AmpSync2-10;
            pause(10)
            errcnt=0;
            while Thresh<AmpSync2-9
                for i=1:5
                    sweep = i
                    fprintf(SA,'SNGLS;TS;')
                    fprintf(SA,'TDF P;TRA?;')
                    A = fscanf(SA);
                    fprintf(SA, 'CONTS;')
                    C(:,i)=strread(A,'%f','delimiter',',');
                    peak(i)=max(C(:,i));
                end
            Thresh=max(peak)
            end
            i=1;
        end
        
        errcnt=errcnt+1
        beep
    end
end

fclose(SA)
fclose(sig)
fclose(WFG)

figure(100*R)
hold on
plot(freq,C)
hold off
drawnow

[BW3dBa(cnt,cnt2) BW3dBe(cnt,cnt2) PeakFa(cnt,cnt2) PeakFe(cnt,cnt2) Qa(cnt,cnt2) Qe(cnt,cnt2) Levela(cnt,cnt2) Levele(cnt,cnt2) Asymma(cnt,cnt2) Asymme(cnt,cnt2)]=resprocessSAspline(B,numswp2,freq,RBW);
%[BW3dBaS(cnt,cnt2) BW3dBeS(cnt,cnt2) PeakFaS(cnt,cnt2) PeakFeS(cnt,cnt2) QaS(cnt,cnt2) QeS(cnt,cnt2) LevelaS(cnt,cnt2) LeveleS(cnt,cnt2) AsymmaS(cnt,cnt2) AsymmeS(cnt,cnt2)]=resprocessSAsync(C,numswp,freq,RBW);
stoptime=fix(clock);

timestamp(cnt,cnt2)=stoptime(6)+1e2*stoptime(5)+1e4*stoptime(4)+1e6*stoptime(3)+1e8*stoptime(2)+1e10*stoptime(1);
time(cnt,cnt2)=etime(stoptime,starttime);

figure(10*R)
subplot(2,1,1)
errorbar(time(:,cnt2)/3600,Qa(:,cnt2), Qe(:,cnt2),'rx')

%if cnt2==1
%    ylabel('Q of 14.014 GHz resonance')
if cnt2==1
    ylabel('Q of 28.5 GHz resonance')
elseif cnt2==2
    ylabel('Q of 16.174 GHz resonance')
end

subplot(2,1,2)
errorbar(time(:,cnt2)/3600,PeakFa(:,cnt2)/1e9, PeakFe(:,cnt2)/1e9,'rx')
ylabel('Center Frequency (GHz)')

xlabel('Time since gas added (hrs)')

%if cnt2==1
save ka_qtrack_nh3_3bars_premix timestamp T1 P1 BW3dBa BW3dBe PeakFa PeakFe Qa Qe Levela Levele Asymma Asymme CentF Bwide time
%else
%save 76_qtrack_nh3_6bars timestamp T1 P1 BW3dBa BW3dBe PeakFa PeakFe Qa Qe Levela Levele Asymma Asymme BW3dBaS BW3dBeS PeakFaS PeakFeS QaS QeS LevelaS LeveleS AsymmaS AsymmeS
%end

end

if mod(cnt,3)==0
    beep
    pause(0.25)
    beep
    input('replace half')
end

end


pause(0.25)
beep
pause(0.25)
beep
pause(0.25)
beep
pause(0.25)
beep