close all
instrreset
clear all
format long

% code for tracking the Q and center frequency of the small cavity resonator

% The user specifies the approximate resonant frequencies to be measured,
% while cnt2 iterates through those resoances and cnt iterates as a
% function of time.  The frequencies should be scaled in line 22 so that they
% can be more easily located.  The file name must be changed in line 355.

% If the code stops for whatever reason, while equilibration is still
% occurring, it should be restarted after commenting out lines 3, 20, and
% changing the first iterator of line 28 to match up with what's already
% been measured.

T1=input('Starting Temperature in deg. C : ');
P1=input('Starting gauge Pressure in bars (-1 for vacuum) : ');
starttime=fix(clock);
Flist=[14.737e9 16.174e9];
Flist=Flist*161328/161740;
Rlist=[62 63];
pwrlist=[6 6];
bigspanlist=[50e6 50e6];
sigspanlist=[10e6 10e6];
RBWlist=[30e3 30e3];
for cnt=1:500
for cnt2=1:2
R=Rlist(cnt2);
F=Flist(cnt2);
RBW=RBWlist(cnt2);
pwr=pwrlist(cnt2);
bigspan=bigspanlist(cnt2);
SigSpan=sigspanlist(cnt2);
MixN=2;
instrreset

numswp=0;       % number of synchronized sweeps
numswp2=5;      % number of unsynchronized sweeps
    
sig = gpib('ni',0,19);
SA = gpib('ni',0,18);
WFG = gpib('ni',0,10);
SA.InputBufferSize=4300;
fopen(sig)
fopen(SA)
fopen(WFG)
set(SA,'Timeout',50)

SweepTime=0.989;
    
VBW=RBW/10;
RBW2=RBW*10;
VBW2=RBW2/10;

fprintf(WFG, 'APPL:SQU 0.55, 0.5, 0.25') %turn trigger off
fprintf(SA, 'BLANK TRB;CLRW TRA;')

fprintf(sig, 'POW:STAT ON')
fprintf(sig, 'SWE:FREQ:GEN ANAL')
fprintf(sig, 'SWE:FREQ:TIME 1')
fprintf(sig, 'POW:LEVEL %f', pwr)
fprintf(sig, 'INIT:CONT 1')
fprintf(SA, 'DET POS;')
fprintf(SA, 'AT 0;')
fprintf(SA, 'RL -10;')
fprintf(SA, 'LG 5DB;')

fprintf(sig, 'FREQ:CENT %f', F)
fprintf(sig, 'FREQ:SPAN %f', bigspan*1.015)
pause(0.25)
fprintf(sig, 'FREQ:SPAN %f', bigspan*1.015)
fprintf(SA, 'CF %f;', F)
fprintf(SA, 'SP %f;', bigspan)
fprintf(SA, 'RB 2e6')
fprintf(SA, 'VB %f', VBW2)
fprintf(SA, 'ST 0.975S;')

fprintf(SA, 'CONTS;')

fprintf(SA, 'TM EXT')
fprintf(sig, 'TRIG:SOUR EXT;') 
fprintf(WFG, 'APPL:SQU 0.9, 2.5, 1.25')
pause(10)
fprintf(SA,'SNGLS;TS;')
fprintf(SA, 'MKPK;')

fprintf(SA, 'MKCF;')
fprintf(SA,'CF?;')
F = fscanf(SA, '%f');
CentF(cnt,cnt2)=F;
fprintf(sig, 'FREQ:CENT %f', F)
fprintf(sig, 'FREQ:SPAN %f', 100e6*1.015)
pause(0.25)
fprintf(sig, 'FREQ:SPAN %f', 100e6*1.015)
fprintf(SA, 'SP %f;', 100e6)
fprintf(SA, 'RB 2e6')
fprintf(SA, 'ST 0.975S;')
fprintf(SA, 'CONTS;')
pause(10)
fprintf(SA,'SNGLS;TS;')
fprintf(SA,'TDF P;TRA?;')
A = fscanf(SA);
Bwidetemp=strread(A,'%f','delimiter',',');
fprintf(SA, 'CONTS;')
Bwide(cnt,cnt2,:)=Bwidetemp;
fprintf(SA, 'SP %f;', SigSpan)
fprintf(sig, 'FREQ:CENT %f', F)
fprintf(sig, 'FREQ:SPAN %f', SigSpan*1.015)
pause(0.25)
fprintf(sig, 'FREQ:SPAN %f', SigSpan*1.015)
fprintf(SA, 'RB %f;', RBW2)
pause(10)
fprintf(SA,'SNGLS;TS;')
fprintf(SA, 'MKPK;')
fprintf(SA, 'MKCF;')
fprintf(SA,'CF?;')
F = fscanf(SA, '%f');

fprintf(SA, 'SP %f;', SigSpan)
fprintf(sig, 'FREQ:CENT %f', F)
fprintf(sig, 'FREQ:SPAN %f', SigSpan*1.015)
pause(0.25)
fprintf(sig, 'FREQ:SPAN %f', SigSpan*1.015)

pause(10)
fprintf(SA,'SNGLS;TS;')
fprintf(SA, 'MKPK HI;MKA?;')
Amp = fscanf(SA, '%f');
Amp = Amp+1-rem(Amp,1);
fprintf(SA, 'RL %f;', Amp)
fprintf(SA, 'LG 1DB;')
fprintf(SA, 'CONTS;')
pause(10)
fprintf(SA,'SNGLS;TS;')
fprintf(SA,'TDF P;TRA?;')
A = fscanf(SA);
B=strread(A,'%f','delimiter',',');
freq=linspace(F-SigSpan/2, F+SigSpan/2, 601);
freqwide=linspace(F-50e6, F+50e6, 601);
[bw3db PeakF]=quickprocess_sync(B,freq);
bw3db=bw3db-rem(bw3db,1e4);
PeakF=PeakF-rem(PeakF,1e4);

fprintf(SA, 'SP %f;', bw3db*2)
fprintf(SA, 'CF %f;', PeakF)
fprintf(SA, 'ST %f;', SweepTime)
fprintf(sig, 'FREQ:CENT %f', PeakF)
fprintf(sig, 'FREQ:SPAN %f', bw3db*2*1.015)
pause(0.25)
fprintf(sig, 'FREQ:SPAN %f', bw3db*2*1.015)

fprintf(SA, 'CONTS;')
fprintf(SA, 'RL %f;', Amp+3)
pause(10)
fprintf(SA,'SNGLS;TS;')
fprintf(SA,'TDF P;TRA?;')
A = fscanf(SA);
B=strread(A,'%f','delimiter',',');
fprintf(SA, 'MKPK HI;MKA?;')
Amp2 = fscanf(SA, '%f');
Amp2 = Amp2+1-rem(Amp2,1);

fprintf(SA, 'RL %f;', Amp2)
fprintf(SA, 'CONTS;')
freq=linspace(PeakF-bw3db, PeakF+bw3db, 601);
[bw3db PeakF]=quickprocess_sync(B,freq);
bw3db=bw3db-rem(bw3db,1e4);
PeakF=PeakF-rem(PeakF,1e4);
SweTime=SweepTime;
if bw3db>(1e6*MixN)
    if bw3db<(1.5e6*MixN)
        bw3db=(1e6*MixN);
    else
    SweTime=0.975;
    end
else
    SweTime=SweepTime;
end

fprintf(SA, 'CF %f;', PeakF)
fprintf(SA, 'SP %f;', bw3db*2)
fprintf(SA,'CF?;')
PeakF = fscanf(SA, '%f');
fprintf(sig, 'FREQ:CENT %f', PeakF)
fprintf(sig, 'FREQ:SPAN %f', bw3db*2*1.015)
pause(0.25)
fprintf(sig, 'FREQ:SPAN %f', bw3db*2*1.015)

fprintf(SA, 'RB %f;', RBW)
fprintf(SA, 'VB %f', VBW)
fprintf(SA, 'TM FREE;')
fprintf(sig, 'TRIG:SOUR IMM;')
fprintf(sig, 'SWE:FREQ:TIME 0.075;') 
fprintf(SA, 'ST 40;')

fprintf(SA,'CF?;')
CenterFreq = fscanf(SA, '%f');
fprintf(SA,'AT?;')
Attenuation = fscanf(SA, '%f');
fprintf(SA,'DET?;')
Detector = fscanf(SA, '%c');
fprintf(SA,'SP?;')
Span = fscanf(SA, '%f');
fprintf(SA,'RB?;')
RBW = fscanf(SA, '%f');
fprintf(SA,'RL?;')
RL = fscanf(SA, '%f');
fprintf(SA,'VB?;')
VBW = fscanf(SA, '%f');
freq=linspace(CenterFreq-Span/2, CenterFreq+Span/2, 601);

fprintf(sig, 'INIT:CONT 1')

long_errcnt=0;
q=1;
while q<=numswp2
    long_sweep = q
    fprintf(sig, 'INIT:CONT 1')
    fprintf(SA,'SNGLS;')
    pause(45)
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    B(:,q)=strread(A,'%f','delimiter',',');
    fprintf(SA, 'CONTS;')
    gooddata=0;
    for k=1:601
        if B(k,q)>RL-10
            gooddata=gooddata+1;
        end
    end
    if gooddata >= 130
        q=q+1;
    else
        fprintf(sig, 'SWE:MODE MAN')
        pause(1)
        fprintf(sig, 'FREQ:CENT %f', CenterFreq)
        pause(1)
        fprintf(sig, 'FREQ:CENT %f', CenterFreq)
        fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
        pause(1)
        fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
        pause(1)
        fprintf(sig, 'INIT:CONT 0')
        pause(1)
        fprintf(sig, 'INIT:CONT 1')
        pause(1)
        fprintf(sig, 'SWE:MODE AUTO')
        pause(1)
        fprintf(sig, 'TRIG:SOUR IMM;')
    end
end

fprintf(WFG, 'APPL:SQU 0.55, 2.5, 1.25')
    fprintf(SA, 'TM EXT')
    fprintf(sig, 'TRIG:SOUR EXT;') 
    fprintf(sig, 'SWE:FREQ:TIME 1;') 
    fprintf(SA, 'ST %f;', SweTime)
    fprintf(SA, 'RB %f;', RBW2)
    
    fprintf(sig, 'SWE:FREQ:GEN ANAL')
    fprintf(SA, 'CONTS;')
    fprintf(sig, 'INIT:CONT 1')
Thresh=Amp-10;

while Thresh<Amp-9
for i=1:1
    sweep = i
    fprintf(SA,'SNGLS;TS;')
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    fprintf(SA, 'CONTS;')
    C(:,i)=strread(A,'%f','delimiter',',');
    peak(i)=max(C(:,i));
end
Thresh=max(peak)
end
    threshtol=0.2

i=1;
errcnt=0;
while i<numswp+1
    sweep = i
    fprintf(SA,'SNGLS;TS;')
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    fprintf(SA, 'CONTS;')
    C(:,i)=strread(A,'%f','delimiter',',');
    peak2=max(C(:,i));
    
    % uncomment if using synchronized sweeps
    %if peak2>(Thresh-threshtol) && C(480,i)~=(Amp-10) && C(120,i)~=(Amp-10)
        i=i+1;
    %else
%         if errcnt==5
%             Thresh=Amp-10;
%             pause(10)
%             errcnt=0;
%             while Thresh<Amp-9
%                 for i=1:5
%                     sweep = i
%                     fprintf(SA,'SNGLS;TS;')
%                     fprintf(SA,'TDF P;TRA?;')
%                     A = fscanf(SA);
%                     fprintf(SA, 'CONTS;')
%                     C(:,i)=strread(A,'%f','delimiter',',');
%                     peak(i)=max(C(:,i));
%                 end
%             Thresh=max(peak)
%             end
%             i=1;
%         end
        
        %errcnt=errcnt+1
        %beep
    %end
end
fclose(SA)
fclose(sig)
fclose(WFG)

    % uncomment if using synchronized sweeps
% figure(100*R)
% hold on
% plot(freq,C)
% hold off
drawnow

[BW3dBa(cnt,cnt2,:) BW3dBe(cnt,cnt2,:) PeakFa(cnt,cnt2) PeakFe(cnt,cnt2) Qa(cnt,cnt2,:) Qe(cnt,cnt2,:) Levela(cnt,cnt2) Levele(cnt,cnt2) Asymma(cnt,cnt2) Asymme(cnt,cnt2)]=resprocessSAtracking(B,numswp2,freq,RBW);
    % uncomment if using synchronized sweeps
%[BW3dBaS(cnt,cnt2) BW3dBeS(cnt,cnt2) PeakFaS(cnt,cnt2) PeakFeS(cnt,cnt2) QaS(cnt,cnt2) QeS(cnt,cnt2) LevelaS(cnt,cnt2) LeveleS(cnt,cnt2) AsymmaS(cnt,cnt2) AsymmeS(cnt,cnt2)]=resprocessSAsync(C,numswp,freq,RBW);
stoptime=fix(clock);

timestamp(cnt,cnt2)=stoptime(6)+1e2*stoptime(5)+1e4*stoptime(4)+1e6*stoptime(3)+1e8*stoptime(2)+1e10*stoptime(1);
time(cnt,cnt2)=etime(stoptime,starttime);

figure(10*R)
subplot(2,1,1)
errorbar(time(:,cnt2)/3600,Qa(:,cnt2), Qe(:,cnt2),'rx')

if cnt2==1      % set appropriate labels for whichever resonances are used
    ylabel('Q of 14.737 GHz resonance')
elseif cnt2==2
    ylabel('Q of 16.174 GHz resonance')
end

subplot(2,1,2)
errorbar(time(:,cnt2)/3600,PeakFa(:,cnt2)/1e9, PeakFe(:,cnt2)/1e9,'rx')
ylabel('Center Frequency (GHz)')
xlabel('Time since gas added (hrs)')

% save the file after each iteration of cnt/cnt2.  Insert new file name for
% each measurement or the previous data will be over-written.
save smallres_qtrack_nh3_8bars_16thpercent 
end
end

pause(0.25)
beep
pause(0.25)
beep
pause(0.25)
beep
pause(0.25)
beep