close all
instrreset
clear all

% Code for taking data from the Agilent 5071C-ENA Vector Network Analyzer
% User lists the approximate frequencies (in GHz) of the resonances to be 
% measured in FrelistGHz and changes the iterator value in line 77 to the
% number of resonances to be measured and the file extension name in line
% 70.  The frequency with which new T and P values are inputted can be
% changed in line 275.  Be careful to use unique file name extensions, or 
% previous data can be over-written.

numpoints=1601;
    numswp=30;
    NA = gpib('ni',0,17);
    NA.InputBufferSize=250000;
    fclose(NA)
    fopen(NA)
    fprintf(NA, ':OUTP ON')
    fprintf(NA, ':SENS1:CORR:CLE')              % clear calibration correction coefficient
    fprintf(NA, ':SENS1:SWE:DEL 0.01')          % sweep delay set to 10ms
    fprintf(NA, ':SENS1:SWE:GEN STEP')          % sweep set to stepped mode
    fprintf(NA, ':SENS1:SWE:POIN 1601')         % set # of points
    fprintf(NA, ':SOUR1:POW 0')                 % set source power to 0 dBm
    fprintf(NA, ':CALC1:FORM MLOG')             % log magnitude format
    IFBW=10000;
    fprintf(NA, ':SENS1:BWID %f;', IFBW)            % Set IF bandwidth for smoothing

    bigspan=50e6;
 
        %FrelistGHz=[1.51055 1.816069 2.02484 2.23424 2.262 2.50814 2.609556 2.71349 2.805187 3.03023 3.092394 3.140038 3.226713 3.316281 3.399456 3.454581 3.497119 3.73155 3.760025 4.255575 4.3059625 4.325406 4.372481 4.425144 4.512081 4.672819 4.749394 5.043675 5.088581 5.122281 5.2571125 5.309806 5.4204 5.50425 5.5962125 5.77895 5.8268875 5.89311875 5.94800625 5.984725 6.0888875 6.3552125 6.5521125 6.769925 6.892225 7.114825 7.3951 7.43599375 7.627 7.8081625 7.869956 8.1850125 8.217513 8.22235 8.294331 8.3935 8.4058 8.48971875];%8.38947 8.4058 8.48971875];
    FrelistGHz=[1.51065 1.81651 2.23507 2.71472 2.80543 3.09294 3.22833 3.45552 3.76203 4.09272 4.32713 4.75168 5.09001 5.31232 5.42356 5.95022 6.35851 7.39851 6.086];%8.38947 8.3935
    zoomspan=5e6;
for k=1:3
    F=FrelistGHz(k)*1e9;
    fprintf(NA, ':CALC1:PAR1:DEF S12')              % measure S(1,2)
    fprintf(NA, ':SENS1:FREQ:CENT %f;', F)          % set center frequency
    fprintf(NA, ':SENS1:FREQ:SPAN %f;', 50e6)       % set frequency span
    fprintf(NA, ':SENS1:SWE:TIME:AUTO ON')          % turn on auto sweep time
    fprintf(NA, ':CALC1:MARK1:FUNC:PEXC 0.0')       % set peak excursion to 0 dB
    fprintf(NA, ':SENS1:SWE:TIME?')                 % query sweep time
    Swetime = fscanf(NA, '%f');
    pause(0.5+Swetime)
    fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')         % set display power axis to auto scale
    fprintf(NA, ':CALC1:MARK1:FUNC:TYPE PEAK')      % specify marker type to peak
    fprintf(NA, ':CALC1:MARK1:FUNC:EXEC')           % search for peak
    fprintf(NA, ':CALC1:MARK1:SET CENT')            % make the center frequency that of the peak
    fprintf(NA, ':SENS1:FREQ:SPAN %f;', zoomspan)   % set frequency span
    fprintf(NA, ':SENS1:SWE:TIME?')                 % query sweep time
    Swetime = fscanf(NA, '%f');
    pause(Swetime+0.5)
    fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
%Zoomed Out
    fprintf(NA, ':CALC1:DATA:FDAT?')
    S21narrowStr = fscanf(NA);
    S21narrow0=strread(S21narrowStr,'%f','delimiter',',');
    fprintf(NA, ':SENS1:FREQ:DATA?')            % query frequency data
    faxisnarrowStr = fscanf(NA);
    faxisnarrow=strread(faxisnarrowStr,'%f','delimiter',',');
    for i=1:3202
    if mod((i+1),2)==0
        S21narrow((i+1)/2)=S21narrow0(i);
    end
    end
    [bw3db PeakF]=quickprocessNA(S21narrow,faxisnarrow);    % quickly locate the peak frequency
    Fratio(k)=PeakF/F;
end
shiftFratio=mean(Fratio);   % used to scale the center frequencies of the other resonances to account for changes in temperature or refractivity

flnm='vac1';
%flnm='nh3_halfbar_1percent';
        beep
        pause(0.25)
        beep
T1=input('Starting Temperature in deg. C : ');
P1=input('Starting gauge Pressure in bars (-1 for vacuum) : ');
for R=1:19
if R <= 19
    numswp=30;
    zoomspan=3e6;
    F=FrelistGHz(R)*1e9;

fprintf(NA, ':CALC1:PAR1:DEF S12')              % measure S(1,2)
fprintf(NA, ':SENS1:FREQ:CENT %f;', F*shiftFratio)  % set center frequency
fprintf(NA, ':SENS1:FREQ:SPAN %f;', zoomspan)   % set frequency span
fprintf(NA, ':SENS1:SWE:TIME:AUTO ON')          % turn on auto sweep time
fprintf(NA, ':CALC1:MARK1:FUNC:PEXC 0.0')       % set peak excursion to 0 dB
fprintf(NA, ':SENS1:SWE:TIME?')                 % query sweep time
Swetime = fscanf(NA, '%f');
pause(0.5+Swetime)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')         % set display power axis to auto scale
fprintf(NA, ':CALC1:MARK1:FUNC:TYPE PEAK')      % specify marker type to peak
fprintf(NA, ':CALC1:MARK1:FUNC:EXEC')           % search for peak
if R~= 19 && R~=17 && R~=14             % resonances that require manual location
    fprintf(NA, ':CALC1:MARK1:SET CENT')            % make the center frequency that of the peak
else
    fprintf(NA, ':CALC1:MARK1:FUNC:PEXC 2.0')   % set peak excursion to 2 dB
    beep
    pause(0.25)
    beep    
    fprintf(NA, ':SENS1:FREQ:SPAN %f;', zoomspan*5)    % set frequency span
    %pause(1)
    input('manually tune to resonance')         % manually move marker to desired peak
    fprintf(NA, ':CALC1:MARK1:SET CENT')        % make the center frequency that of the peak
    fprintf(NA, ':CALC1:MARK1:FUNC:PEXC 0.0')   % set peak excursion to 0 dB
end
fprintf(NA, ':SENS1:SWE:POIN %i;', 1601)         % set # of points

fprintf(NA, ':SENS1:FREQ:SPAN %f;', bigspan)    % set frequency span
fprintf(NA, ':SENS1:SWE:TIME?')                 % query sweep time
Swetime = fscanf(NA, '%f');
pause(Swetime+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
%Zoomed Out
fprintf(NA, ':SENS1:FREQ:DATA?')            % query frequency data
faxiswideStr = fscanf(NA);
faxiswide=strread(faxiswideStr,'%f','delimiter',',');
fprintf(NA, ':CALC1:DATA:FDAT?')
S12wideStr = fscanf(NA);
S12wide0=strread(S12wideStr,'%f','delimiter',',');

fprintf(NA, ':CALC1:PAR1:DEF S11')          % measure S(1,1)
pause(Swetime+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:DATA:FDAT?')
S11wideStr = fscanf(NA);
S11wide0=strread(S11wideStr,'%f','delimiter',',');

fprintf(NA, ':CALC1:PAR1:DEF S22')          % measure S(2,2)
pause(Swetime+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:DATA:FDAT?')
S22wideStr = fscanf(NA);
S22wide0=strread(S22wideStr,'%f','delimiter',',');

fprintf(NA, ':CALC1:PAR1:DEF S21')          % measure S(2,1)
pause(Swetime+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:DATA:FDAT?')
S21wideStr = fscanf(NA);
S21wide0=strread(S21wideStr,'%f','delimiter',',');

fprintf(NA, ':SENS1:FREQ:SPAN %f;', zoomspan);    % set frequency span

pause(Swetime+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:MARK1:FUNC:TYPE PEAK')      % specify marker type to peak
fprintf(NA, ':CALC1:MARK1:FUNC:EXEC')           % search for peak
fprintf(NA, ':CALC1:MARK1:SET CENT')            % make the center frequency that of the peak
pause(Swetime+0.5)
fprintf(NA, ':CALC1:DATA:FDAT?')
S21narrowStr = fscanf(NA);
S21narrow0=strread(S21narrowStr,'%f','delimiter',',');
fprintf(NA, ':SENS1:FREQ:DATA?')            % query frequency data
faxisnarrowStr = fscanf(NA);
faxisnarrow=strread(faxisnarrowStr,'%f','delimiter',',');
for i=1:3202
if mod((i+1),2)==0
    S21narrow((i+1)/2)=S21narrow0(i);
end
end
[bw3db PeakF]=quickprocessNA(S21narrow,faxisnarrow);
bw3db=bw3db-rem(bw3db,1e4);
PeakF=PeakF-rem(PeakF,1e3);

%Zoomed In
fprintf(NA, ':SENS1:FREQ:SPAN %f;', bw3db*3)    % set frequency span
fprintf(NA, ':SENS1:FREQ:CENT %f;', PeakF)      % set center frequency
fprintf(NA, ':SENS1:SWE:POIN %i;', numpoints)   % set # of points
fprintf(NA, ':SENS1:SWE:TIME?')                 % query sweep time
Swetime2 = fscanf(NA, '%f');
pause(Swetime2+0.5)

fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:MARK1:FUNC:TYPE PEAK')      % specify marker type to peak
fprintf(NA, ':CALC1:MARK1:FUNC:EXEC')           % search for peak
fprintf(NA, ':CALC1:MARK1:SET CENT')            % make the center frequency that of the peak
pause(Swetime2+0.5)
fprintf(NA, ':SENS1:FREQ:DATA?')                % query frequency data
faxisStr = fscanf(NA);
faxis=strread(faxisStr,'%f','delimiter',',');
for j=1:numswp                                  % measure S(2,1)
    fprintf(NA, ':CALC1:DATA:FDAT?')
    S21Str = fscanf(NA);
    S210=strread(S21Str,'%f','delimiter',',');
    for i=1:2*numpoints
        if mod((i+1),2)==0
            S21((i+1)/2,j)=S210(i);
        end
    end
    pause(Swetime2+.1)
end
fprintf(NA, ':CALC1:PAR1:DEF S12')              % measure S(1,2)
pause(Swetime2+0.5)
for j=1:numswp                                  
    fprintf(NA, ':CALC1:DATA:FDAT?')
    S12Str = fscanf(NA);
    S120=strread(S12Str,'%f','delimiter',',');
    for i=1:2*numpoints
        if mod((i+1),2)==0
            S12((i+1)/2,j)=S120(i);
        end
    end
    pause(Swetime2+.1)
end
fprintf(NA, ':CALC1:PAR1:DEF S22')              % measure S(2,2)
pause(Swetime2+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:DATA:FDAT?')
S22Str = fscanf(NA);
S220=strread(S22Str,'%f','delimiter',',');
for i=1:2*numpoints
    if mod((i+1),2)==0
        S22((i+1)/2)=S220(i);
    end
end
pause(Swetime2)
fprintf(NA, ':CALC1:PAR1:DEF S11')              % measure S(1,1)
pause(Swetime2+0.5)
fprintf(NA, ':DISP:WIND1:TRAC1:Y:AUTO')     % set display power axis to auto scale
fprintf(NA, ':CALC1:DATA:FDAT?')
S11Str = fscanf(NA);
S110=strread(S11Str,'%f','delimiter',',');
for i=1:2*numpoints
    if mod((i+1),2)==0
        S11((i+1)/2)=S110(i);
    end
end


%parse data
for i=1:2*numpoints
if mod((i+1),2)==0
    S11wide((i+1)/2)=S11wide0(i);
    S12wide((i+1)/2)=S12wide0(i);
    S21wide((i+1)/2)=S21wide0(i);
    S22wide((i+1)/2)=S22wide0(i);
end
end
figure(R)                   % display all data
subplot(2,2,1)
plot(faxiswide,S11wide)
title('S(1,1)')
subplot(2,2,2)
plot(faxiswide,S12wide)
title('S(1,2)')
subplot(2,2,3)
plot(faxiswide,S21wide)
title('S(2,1)')
subplot(2,2,4)
plot(faxiswide,S22wide)
title('S(2,2)')
figure(100*R)
subplot(2,2,1)
plot(faxis,S11)
title('S(1,1)')
subplot(2,2,2)
plot(faxis,S12)
title('S(1,2)')
subplot(2,2,3)
plot(faxis,S21)
title('S(2,1)')
subplot(2,2,4)
plot(faxis,S22)
title('S(2,2)')

else
    disp('invalid input for resonance #');
end

time=fix(clock);

T2=T1;
P2=P1;
if mod(R,9)==0                  % sets how often to ask for new T and P readings
beep
pause(0.25)
beep
T2=input('Finishing Temperature in deg. C : ');
P2=input('Finishing gauge Pressure in bars (-1 for vacuum) : ');
%P2=-1;         % uncomment for vacuum measurements
end

timestamp=num2str(time(6)+1e2*time(5)+1e4*time(4)+1e6*time(3)+1e8*time(2)+1e10*time(1));
Rs=num2str(R);

filename=strcat(Rs,'_', flnm);;
clear *Str *0
save (filename)

T1=T2;          % carry over T and P for the next resonance measurement
P1=P2;
end
fclose(NA)
pause(0.25)    
beep            % alert the user that the measurements are complete
pause(0.25)
beep
pause(0.25)
beep
pause(0.25)
beep