close all
instrreset
clear all

% code for taking transmissivity measurements using the HP8564E spectrum analyzer

% the user specifies the appropriate file name extensions in the beginning
% and end of the code along with the lists of measurements to iterate
% through and the number of resonances.  The number of the transmissivity
% measurement (1, 2, or 3) is specified in line 13.  The dimensions of the
% plotting window are set in line 284.

Transnum='16';

%for R=60:70
for R=85:89
for pressures=1:7
%for pressures=1:1

for NAuse=1:1
    Rstr=num2str(R);
    if pressures==1
        if NAuse==1
            filenm=strcat(Rstr, '_nh3_12bars_1percent');
        else
            filenm=strcat(Rstr, '_h2o_300mb_pure');
        end        
    elseif pressures==2
        if NAuse==1
            filenm=strcat(Rstr, '_nh3_4bars_1percent');
        else
            filenm=strcat(Rstr, '_h2o_12bars');
        end        
    elseif pressures==3
        if NAuse==1
            filenm=strcat(Rstr, '_nh3_4bars_quarterpercent');
        else
            filenm=strcat(Rstr, '_h2o_8bars');
        end
    elseif pressures==4
        if NAuse==1
            filenm=strcat(Rstr, '_nh3_halfbar_premix');
        else
            filenm=strcat(Rstr, '_h2o_4bars');
        end
    elseif pressures==5
        if NAuse==1
            filenm=strcat(Rstr, '_nh3_1bar_premix');
        else
            filenm=strcat(Rstr, '_nh3_8bars_thirdpercent');
        end      
    elseif pressures==6
        if NAuse==1
            filenm=strcat(Rstr, '_nh3_2bars_premix');
        else
            filenm=strcat(Rstr, '_nh3_4bars_thirdpercent');
        end     
    elseif pressures==7
        if NAuse==1
            filenm=strcat(Rstr, '_nh3_3bars_premix');
        else
            filenm=strcat(Rstr, '_nh3_3bars_premix');
        end             
    elseif pressures==8
        if NAuse==1
            filenm=strcat(Rstr, '_nh3_quarterbar_100percent');
        else
            filenm=strcat(Rstr, '_nh3_32ndbar');
        end
    elseif pressures==9
        if NAuse==1
            filenm=strcat(Rstr, '_nh3_quarterbar_100percent');
        else
            filenm=strcat(Rstr, '_nh3_quarterbar_100percent');
        end        
    end
        % next lines are used for excluding measurements that don't exist
%  if pressures==1 && (R==61 || R==62 || R==65 || R==66 || R==67 || R==68 || R==70)
%  elseif pressures==2 && (R==61 || R==62 || R==65 || R==66 || R==67 || R==68)
%  elseif pressures==3 && (R==61 || R==62 || R==65 || R==66 || R==67 || R==68)
%  elseif pressures==4 && (R==61 || R==62 || R==65 || R==66 || R==67 || R==68)
%  elseif pressures==5 && (R==61 || R==62 || R==68)
%  elseif pressures==6 && (R==61 || R==62)
%  elseif pressures==7 && (R==60 || R==61 || R==62 || R==65 || R==66 || R==67 || R==68)
%  else
    load (filenm)
    B=0;
    clear B C
    numpoints=1601;
    peak=0;
    SweepTime2=20;
    
%R=input('Resonance # (1-30): ');


instrreset

sig = gpib('ni',0,19);
SA = gpib('ni',0,18);
WFG = gpib('ni',0,10);
SA.InputBufferSize=4300;
fopen(sig)
fopen(SA)
fopen(WFG)
numswp=1;
numswp2=3;
fprintf(WFG, 'APPL:SQU 0.55, 0.5, 0.25') %turn trigger off
set(SA,'Timeout',SweepTime2+10)
                

    if R==50 && pressures==1 && NAuse == 0
        beep
        pause(0.25)
        beep
        fprintf(sig, 'POW:STAT OFF')
        input('connect large resonator with Pasternack K-band isolator')
    end      
    if R==60 && pressures==1 && NAuse == 0
        beep
        pause(0.25)
        beep
        fprintf(sig, 'POW:STAT OFF')
        input('insert Pasternack K-band isolator')
    end  
    if R==85 && pressures==1 && NAuse == 0
        beep
        pause(0.25)
        beep
        fprintf(sig, 'POW:STAT OFF')
        input('connect ka-band Fabry-Perot resonator')
    end        

fprintf(sig, 'POW:STAT ON')
fprintf(sig, 'SWE:FREQ:GEN ANAL')
fprintf(sig, 'SWE:FREQ:TIME 75e-3')
fprintf(sig, 'POW:LEVEL -10')
fprintf(SA, 'TM FREE;')
fprintf(sig, 'TRIG:SOUR IMM;')
fprintf(SA, 'RL -10;')
RL=-10;

fprintf(SA, 'DET POS;')
fprintf(SA, 'AT 0;')

fprintf(SA, 'LG 2DB;')

fprintf(sig, 'FREQ:CENT %f', CenterFreq)
pause(1)
fprintf(sig, 'FREQ:CENT %f', CenterFreq)
fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
pause(1)
fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
fprintf(SA, 'CF %f;', CenterFreq)
fprintf(SA, 'SP %f;', Span)
fprintf(SA, 'RB %f;', RBW)
fprintf(SA, 'VB %f;', VBW)
fprintf(SA, 'ST %f;', SweepTime2)
fprintf(SA, 'CONTS;')
fprintf(SA,'CF?;')
CenterFreq = fscanf(SA, '%f');
fprintf(SA,'AT?;')
Attenuation = fscanf(SA, '%f');
fprintf(SA,'DET?;')
Detector = fscanf(SA, '%c');
fprintf(SA,'SP?;')
Span = fscanf(SA, '%f');
fprintf(SA,'RB?;')
RBW = fscanf(SA, '%f');
fprintf(SA,'VB?;')
VBW = fscanf(SA, '%f');
freq=linspace(CenterFreq-Span/2, CenterFreq+Span/2, 601);
i=1;

% Allow for signals to stabilize on noisy resonances 
pause(20)
if (R==66||R==67||R==68||R==62||R==63||R==64) && pressures==1 && NAuse == 1
    pause(400)
elseif (R==85||R==86) && pressures==4 && NAuse == 1
    pause(600)
end

while i<=numswp2
    longsweep = i
    fprintf(SA,'SNGLS;')
    pause(SweepTime2+5)
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    B(:,i)=strread(A,'%f','delimiter',',');
    fprintf(SA, 'CONTS;')
    gooddata=0;
    for k=1:601
        if B(k,i)>RL-20
            gooddata=gooddata+1;
        end
    end
    if gooddata >= 130
        i=i+1;
    else
        fprintf(sig, 'SWE:MODE MAN')
        pause(1)
        fprintf(sig, 'FREQ:CENT %f', CenterFreq)
        pause(1)
        fprintf(sig, 'FREQ:CENT %f', CenterFreq)
        fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
        pause(1)
        fprintf(sig, 'FREQ:SPAN %f', Span*1.015)
        pause(1)
        fprintf(sig, 'INIT:CONT 0')
        pause(1)
        fprintf(sig, 'INIT:CONT 1')
        pause(1)
        fprintf(sig, 'SWE:MODE AUTO')
        pause(1)
        fprintf(sig, 'TRIG:SOUR IMM;')
    end
end
    B=B+10+pwr;
    
    fprintf(SA, 'TM EXT')
    fprintf(sig, 'TRIG:SOUR EXT;') 
    fprintf(sig, 'SWE:FREQ:TIME 1;')    
    fprintf(SA, 'RB %f;', RBW2)
    fprintf(SA, 'VB %f;', VBW)
    fprintf(SA, 'ST %f;', SweTime)
    
    fprintf(sig, 'SWE:FREQ:GEN ANAL')
    fprintf(SA, 'CONTS;')
    fprintf(sig, 'INIT:CONT 1')
    fprintf(WFG, 'APPL:SQU 0.55, 2.5, 1.25')
    Thresh=-20+RL;

while Thresh<-19+RL
for i=1:1
    sweep = i
    fprintf(SA,'SNGLS;TS;')
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    fprintf(SA, 'CONTS;')
    C(:,i)=strread(A,'%f','delimiter',',');
    peak(i)=max(C(:,i));
end
Thresh=max(peak)
end

threshtol=0.2

i=1;
errcnt=0;
while i<numswp+1
    sweep = i
    fprintf(SA,'SNGLS;TS;')
    fprintf(SA,'TDF P;TRA?;')
    A = fscanf(SA);
    fprintf(SA, 'CONTS;')
    C(:,i)=strread(A,'%f','delimiter',',');
    peak2=max(C(:,i));
        i=i+1;
        if errcnt==5
            Thresh=-20+RL;
            pause(10)
            errcnt=0;
            while Thresh<-19+RL
                for i=1:3
                    sweep = i
                    fprintf(SA,'SNGLS;TS;')
                    fprintf(SA,'TDF P;TRA?;')
                    A = fscanf(SA);
                    fprintf(SA, 'CONTS;')
                    C(:,i)=strread(A,'%f','delimiter',',');
                    peak(i)=max(C(:,i));
                end
            Thresh=max(peak)
            end
            i=1;
        end
        
end
fclose(SA)
fclose(sig)
fclose(WFG)    
    
C=C+10+pwr;
figure(R*100+NAuse)
subplot(2,2,pressures)    % plot each transmissivity measurement as a subplot in a window for each resonance.
% dimensions of subplot must be changed to accomodate all the measurements
plot(freq,B)
hold on
plot(freq,C)

time=fix(clock);
timestamp=num2str(time(6)+1e2*time(5)+1e4*time(4)+1e6*time(3)+1e8*time(2)+1e10*time(1));
Rs=num2str(R);
    if pressures==1  
        if NAuse==1
            filename=strcat(Rs,'_trans',Transnum, '_12bars_1percent');
        else
            filename=strcat(Rs,'_trans',Transnum, '_300mb_pure');
        end
    elseif pressures==2
        if NAuse==1
            filename=strcat(Rs,'_trans',Transnum, '_4bars_1percent');
        else
            filename=strcat(Rs,'_trans',Transnum, '_12bars');
        end
    elseif pressures==3
        if NAuse==1
            filename=strcat(Rs,'_trans',Transnum, '_4bars_quarterpercent');
        else
            filename=strcat(Rs,'_trans',Transnum, '_8bars');
        end
    elseif pressures==4
        if NAuse==1
            filename=strcat(Rs,'_trans',Transnum, '_halfbar_premix');
        else
            filename=strcat(Rs,'_trans',Transnum, '_4bars');
        end
    elseif pressures==5
        if NAuse==1
            filename=strcat(Rs,'_trans',Transnum, '_1bar_premix');
        else
            filename=strcat(Rs,'_trans',Transnum, '_8bars_thirdpercent');
        end   
    elseif pressures==6
        if NAuse==1
            filename=strcat(Rs,'_trans',Transnum, '_2bars_premix');
        else
            filename=strcat(Rs,'_trans',Transnum, '_4bars_thirdpercent');
        end  
    elseif pressures==7
        if NAuse==1
            filename=strcat(Rs,'_trans',Transnum, '_3bars_premix');
        else
            filename=strcat(Rs,'_trans',Transnum, '_3bars_premix');
        end         
    elseif pressures==8
        if NAuse==1
            filename=strcat(Rs,'_trans',Transnum, '_quarterbar_100percent');
        else
            filename=strcat(Rs,'_trans',Transnum, '_32ndbar');
        end
    elseif pressures==9
        if NAuse==1
            filename=strcat(Rs,'_trans',Transnum, '_quarterbar_100percent');
        else
            filename=strcat(Rs,'_trans',Transnum, '_quarterbar_100percent');
        end        
    end
clear *Str *0
save (filename)

end

hold off
end
end

pause(0.25)
beep            % alert the user that the measurements are complete
pause(0.25)
beep
pause(0.25)
beep
pause(0.25)
beep