function [bw3db PeakF]=quickprocessNA(B,freq)

% quick script for finding the approximate center frequency and amplitude 
% of a data sweep from the network analyzer

format long
Boriginal=B;

nofa=0;
nofb=0;

fre=linspace(freq(1),freq(length(freq)), 1001);
[pp, p]=csaps(freq,B);  
[pp, p2]=csaps(freq,B,p*1e-3);      % enhance default smoothing tolerance by 1000
Po=ppval(pp,fre);
[peak, location]=max(Po);
threshold=ppval(pp,fre(location))-3;
PeakF=fre(location);
q=location;
while Po(q)>threshold
    q=q+1;
    if q==1001
        disp('upper 3dB point not found, interpolating...')
        nofb=1;
        break 
    end
end
if nofb==1
    dfb=(Po(1001)-threshold)*(fre(1001)-fre(1000))/(Po(1000)-Po(1001));  % linear interpolation
    fb=fre(1001)+dfb;
else
    fb=(Po(q-1)-threshold)*(fre(q)-fre(q-1))/(Po(q-1)-Po(q))+fre(q-1);  % linear interpolation
end

q=location;
while Po(q)>threshold
    q=q-1;
    if q==0;
        disp('lower 3dB point not found, interpolating...')
        nofa=1;
        break
    end
end
if nofa==1
    dfa=(Po(1)-threshold)*(fre(2)-fre(1))/(Po(2)-Po(1));  % linear interpolation
    fa=fre(1)-dfa;
else
    fa=fre(q+1)-(Po(q+1)-threshold)*(fre(q+1)-fre(q))/(Po(q+1)-Po(q));  % linear interpolation
end

bw3db=(fb-fa);

B=Boriginal;