function [bw3db PeakF]=quickprocess_sync(B,freq)

% quick script for finding the approximate center frequency and amplitude 
% of a data sweep from the spectrum analyzer

format long
Boriginal=B;
nofa=0;
nofb=0;

% No smoothing involved

[peak, location]=max(B);
threshold=peak-3;
q=location;
while B(q)>threshold
    q=q+1;
    if q==602
        disp('upper 3dB point not found, interpolating...')
        nofb=1;
        break 
    end
end
if nofb==1
    dfb=(B(601)-threshold)*(freq(601)-freq(600))/(B(600)-B(601));  % linear interpolation
    fb=freq(601)+dfb;
else
    fb=(B(q-1)-threshold)*(freq(q)-freq(q-1))/(B(q-1)-B(q))+freq(q-1);  % linear interpolation
end

q=location;
while B(q)>threshold
    q=q-1;
    if q==0;
        disp('lower 3dB point not found, interpolating...')
        nofa=1;
        break
    end
end
if nofa==1
    dfa=(B(1)-threshold)*(freq(2)-freq(1))/(B(2)-B(1));  % linear interpolation
    fa=freq(1)-dfa;
else
    fa=freq(q+1)-(B(q+1)-threshold)*(freq(q+1)-freq(q))/(B(q+1)-B(q));  % linear interpolation
end

bw3db=(fb-fa);
PeakF=freq(location);

B=Boriginal;